--Legal Notice: (C)2010 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_FIR_FIR_HW_output_buffer0 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_a0 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_be0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_d0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_we0 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_output_buffer0;


architecture europa of accelerator_FIR_FIR_HW_output_buffer0 is
  component altsyncram is
GENERIC (
      byte_size : NATURAL;
        implement_in_les : STRING;
        lpm_type : STRING;
        numwords_a : NATURAL;
        operation_mode : STRING;
        outdata_reg_a : STRING;
        ram_block_type : STRING;
        read_during_write_mode_mixed_ports : STRING;
        width_a : NATURAL;
        width_byteena_a : NATURAL;
        widthad_a : NATURAL
      );
    PORT (
    signal q_a : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
        signal wren_a : IN STD_LOGIC;
        signal byteena_a : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
        signal clock0 : IN STD_LOGIC;
        signal address_a : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
        signal data_a : IN STD_LOGIC_VECTOR (31 DOWNTO 0)
      );
  end component altsyncram;
                signal internal_accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  the_accelerator_FIR_FIR_HW_output_buffer_internal_memory0 : altsyncram
    generic map(
      byte_size => 8,
      implement_in_les => "OFF",
      lpm_type => "altsyncram",
      numwords_a => 1024,
      operation_mode => "SINGLE_PORT",
      outdata_reg_a => "UNREGISTERED",
      ram_block_type => "AUTO",
      read_during_write_mode_mixed_ports => "DONT_CARE",
      width_a => 32,
      width_byteena_a => 4,
      widthad_a => 10
    )
    port map(
            address_a => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_a0,
            byteena_a => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_be0,
            clock0 => clk,
            data_a => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_d0,
            q_a => internal_accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q1,
            wren_a => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_we0
    );

  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0 <= internal_accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q1;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- c_subroutine_block
--../fir_hw.c (45): void FIR_HW(short * input_data,
entity accelerator_FIR_FIR_HW_FIR_HW0_state_machine_subroutine_0 is 
        port (
              -- inputs:
                 signal FIR_HW_begin0 : IN STD_LOGIC;
                 signal FIR_HW_read0 : IN STD_LOGIC;
                 signal FIR_HW_select0 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal inhibit_from_c_do_block0 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal FIR_HW_state0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal advance_to_FIR_HW_state0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal enable_FIR_HW_state0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_FIR_HW0_state_machine_subroutine_0;


architecture europa of accelerator_FIR_FIR_HW_FIR_HW0_state_machine_subroutine_0 is
                signal block_wide_enable0 :  STD_LOGIC;
                signal internal_FIR_HW_state0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_advance_to_FIR_HW_state0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_enable_FIR_HW_state0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_FIR_HW_state0(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_FIR_HW_state0(0)) = '1' then 
        internal_FIR_HW_state0(0) <= internal_advance_to_FIR_HW_state0(0);
      end if;
    end if;

  end process;

  internal_enable_FIR_HW_state0(0) <= block_wide_enable0;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_FIR_HW_state0(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_FIR_HW_state0(1)) = '1' then 
        internal_FIR_HW_state0(1) <= internal_advance_to_FIR_HW_state0(1);
      end if;
    end if;

  end process;

  internal_enable_FIR_HW_state0(1) <= block_wide_enable0;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_FIR_HW_state0(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_FIR_HW_state0(2)) = '1' then 
        internal_FIR_HW_state0(2) <= internal_advance_to_FIR_HW_state0(2);
      end if;
    end if;

  end process;

  internal_enable_FIR_HW_state0(2) <= block_wide_enable0;
  internal_enable_FIR_HW_state0(3) <= block_wide_enable0;
  internal_advance_to_FIR_HW_state0(0) <= (FIR_HW_read0 AND FIR_HW_select0) AND FIR_HW_begin0;
  --advance_to_FIR_HW_state0[1] assign, which is an e_assign
  internal_advance_to_FIR_HW_state0(1) <= internal_FIR_HW_state0(0);
  --advance_to_FIR_HW_state0[2] assign, which is an e_assign
  internal_advance_to_FIR_HW_state0(2) <= internal_FIR_HW_state0(1);
  --advance_to_FIR_HW_state0[3] assign, which is an e_assign
  internal_advance_to_FIR_HW_state0(3) <= internal_FIR_HW_state0(2);
  --block_wide_enable0 inhibitor mux, which is an e_mux
  block_wide_enable0 <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(inhibit_from_c_do_block0)))) AND std_logic_vector'("00000000000000000000000000000001")));
  --vhdl renameroo for output signals
  FIR_HW_state0 <= internal_FIR_HW_state0;
  --vhdl renameroo for output signals
  advance_to_FIR_HW_state0 <= internal_advance_to_FIR_HW_state0;
  --vhdl renameroo for output signals
  enable_FIR_HW_state0 <= internal_enable_FIR_HW_state0;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- c_subroutine_block
--../fir_hw.c (87):   {
entity accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_0 is 
        port (
              -- inputs:
                 signal advance_to_FIR_HW_state0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal break49 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal break50 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_FIR_HW_state0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal go_bit_control_output1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal inhibit_from_c_do_block1 : IN STD_LOGIC;
                 signal inhibit_from_c_do_block2 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal advance_to_state_do_2 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal enable_state_do_2 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal inhibit_from_c_do_block0 : OUT STD_LOGIC;
                 signal state_do_2 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_0;


architecture europa of accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_0 is
                signal block_wide_enable1 :  STD_LOGIC;
                signal internal_advance_to_state_do_2 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal internal_enable_state_do_2 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal internal_state_do_2 :  STD_LOGIC_VECTOR (5 DOWNTO 0);

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_2(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_2(0)) = '1' then 
        internal_state_do_2(0) <= internal_advance_to_state_do_2(0);
      end if;
    end if;

  end process;

  internal_enable_state_do_2(0) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_2(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_2(1)) = '1' then 
        internal_state_do_2(1) <= internal_advance_to_state_do_2(1);
      end if;
    end if;

  end process;

  internal_enable_state_do_2(1) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_2(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_2(2)) = '1' then 
        internal_state_do_2(2) <= internal_advance_to_state_do_2(2);
      end if;
    end if;

  end process;

  internal_enable_state_do_2(2) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_2(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_2(3)) = '1' then 
        internal_state_do_2(3) <= internal_advance_to_state_do_2(3);
      end if;
    end if;

  end process;

  internal_enable_state_do_2(3) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_2(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_2(4)) = '1' then 
        internal_state_do_2(4) <= internal_advance_to_state_do_2(4);
      end if;
    end if;

  end process;

  internal_enable_state_do_2(4) <= block_wide_enable1;
  internal_enable_state_do_2(5) <= block_wide_enable1;
  --advance_to_state_do_2[0] assign, which is an e_assign
  internal_advance_to_state_do_2(0) <= Vector_To_Std_Logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((enable_FIR_HW_state0(1) AND advance_to_FIR_HW_state0(1)))))) AND go_bit_control_output1) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(internal_state_do_2(0)))))));
  --advance_to_state_do_2[1] assign, which is an e_assign
  internal_advance_to_state_do_2(1) <= ((internal_state_do_2(0) OR internal_advance_to_state_do_2(3))) AND NOT((or_reduce(break49)));
  --advance_to_state_do_2[2] assign, which is an e_assign
  internal_advance_to_state_do_2(2) <= (internal_state_do_2(1)) AND NOT((or_reduce(break49)));
  --advance_to_state_do_2[3] assign, which is an e_assign
  internal_advance_to_state_do_2(3) <= (internal_state_do_2(2)) AND NOT((or_reduce(break49)));
  --advance_to_state_do_2[4] assign, which is an e_assign
  internal_advance_to_state_do_2(4) <= internal_state_do_2(3);
  --advance_to_state_do_2[5] assign, which is an e_assign
  internal_advance_to_state_do_2(5) <= internal_state_do_2(4);
  --on/inhibit register for c_do_block, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      inhibit_from_c_do_block0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if ((break50 AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_enable_state_do_2(5) AND internal_advance_to_state_do_2(5)))))))) /= std_logic_vector'("00000000000000000000000000000000") then 
        inhibit_from_c_do_block0 <= std_logic'('0');
      elsif ((go_bit_control_output1 AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((enable_FIR_HW_state0(1) AND advance_to_FIR_HW_state0(1)))))))) /= std_logic_vector'("00000000000000000000000000000000") then 
        inhibit_from_c_do_block0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      end if;
    end if;

  end process;

  --block_wide_enable1 inhibitor mux, which is an e_mux
  block_wide_enable1 <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT(inhibit_from_c_do_block1) AND NOT(inhibit_from_c_do_block2))))) AND std_logic_vector'("00000000000000000000000000000001")));
  --vhdl renameroo for output signals
  advance_to_state_do_2 <= internal_advance_to_state_do_2;
  --vhdl renameroo for output signals
  enable_state_do_2 <= internal_enable_state_do_2;
  --vhdl renameroo for output signals
  state_do_2 <= internal_state_do_2;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- c_subroutine_block
--../fir_hw.c (90):     {
entity accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_1 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 : IN STD_LOGIC;
                 signal advance_to_state_do_2 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal break2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal break34 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_2 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal go_bit_control_output3 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal advance_to_state_do_0 : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal enable_state_do_0 : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal inhibit_from_c_do_block1 : OUT STD_LOGIC;
                 signal state_do_0 : OUT STD_LOGIC_VECTOR (19 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_1;


architecture europa of accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_1 is
                signal block_wide_enable2 :  STD_LOGIC;
                signal internal_advance_to_state_do_0 :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal internal_enable_state_do_0 :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal internal_state_do_0 :  STD_LOGIC_VECTOR (19 DOWNTO 0);

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(0)) = '1' then 
        internal_state_do_0(0) <= internal_advance_to_state_do_0(0);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(0) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(1)) = '1' then 
        internal_state_do_0(1) <= internal_advance_to_state_do_0(1);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(1) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(2)) = '1' then 
        internal_state_do_0(2) <= internal_advance_to_state_do_0(2);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(2) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(3)) = '1' then 
        internal_state_do_0(3) <= internal_advance_to_state_do_0(3);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(3) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(4)) = '1' then 
        internal_state_do_0(4) <= internal_advance_to_state_do_0(4);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(4) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(5) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(5)) = '1' then 
        internal_state_do_0(5) <= internal_advance_to_state_do_0(5);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(5) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(6) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(6)) = '1' then 
        internal_state_do_0(6) <= internal_advance_to_state_do_0(6);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(6) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(7) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(7)) = '1' then 
        internal_state_do_0(7) <= internal_advance_to_state_do_0(7);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(7) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(8) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(8)) = '1' then 
        internal_state_do_0(8) <= internal_advance_to_state_do_0(8);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(8) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(9) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(9)) = '1' then 
        internal_state_do_0(9) <= internal_advance_to_state_do_0(9);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(9) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(10) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(10)) = '1' then 
        internal_state_do_0(10) <= internal_advance_to_state_do_0(10);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(10) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(11) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(11)) = '1' then 
        internal_state_do_0(11) <= internal_advance_to_state_do_0(11);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(11) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(12) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(12)) = '1' then 
        internal_state_do_0(12) <= internal_advance_to_state_do_0(12);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(12) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(13) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(13)) = '1' then 
        internal_state_do_0(13) <= internal_advance_to_state_do_0(13);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(13) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(14) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(14)) = '1' then 
        internal_state_do_0(14) <= internal_advance_to_state_do_0(14);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(14) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(15) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(15)) = '1' then 
        internal_state_do_0(15) <= internal_advance_to_state_do_0(15);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(15) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(16) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(16)) = '1' then 
        internal_state_do_0(16) <= internal_advance_to_state_do_0(16);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(16) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(17) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(17)) = '1' then 
        internal_state_do_0(17) <= internal_advance_to_state_do_0(17);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(17) <= block_wide_enable2;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(18) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(18)) = '1' then 
        internal_state_do_0(18) <= internal_advance_to_state_do_0(18);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(18) <= block_wide_enable2;
  internal_enable_state_do_0(19) <= block_wide_enable2;
  --advance_to_state_do_0[0] assign, which is an e_assign
  internal_advance_to_state_do_0(0) <= Vector_To_Std_Logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((enable_state_do_2(1) AND advance_to_state_do_2(1)))))) AND go_bit_control_output3) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(internal_state_do_0(0)))))));
  --advance_to_state_do_0[1] assign, which is an e_assign
  internal_advance_to_state_do_0(1) <= ((internal_state_do_0(0) OR internal_advance_to_state_do_0(2))) AND NOT((or_reduce(break2)));
  --advance_to_state_do_0[2] assign, which is an e_assign
  internal_advance_to_state_do_0(2) <= (internal_state_do_0(1)) AND NOT((or_reduce(break2)));
  --advance_to_state_do_0[3] assign, which is an e_assign
  internal_advance_to_state_do_0(3) <= internal_state_do_0(2);
  --advance_to_state_do_0[4] assign, which is an e_assign
  internal_advance_to_state_do_0(4) <= internal_state_do_0(3);
  --advance_to_state_do_0[5] assign, which is an e_assign
  internal_advance_to_state_do_0(5) <= internal_state_do_0(4);
  --advance_to_state_do_0[6] assign, which is an e_assign
  internal_advance_to_state_do_0(6) <= internal_state_do_0(5);
  --advance_to_state_do_0[7] assign, which is an e_assign
  internal_advance_to_state_do_0(7) <= internal_state_do_0(6);
  --advance_to_state_do_0[8] assign, which is an e_assign
  internal_advance_to_state_do_0(8) <= internal_state_do_0(7);
  --advance_to_state_do_0[9] assign, which is an e_assign
  internal_advance_to_state_do_0(9) <= internal_state_do_0(8);
  --advance_to_state_do_0[10] assign, which is an e_assign
  internal_advance_to_state_do_0(10) <= internal_state_do_0(9);
  --advance_to_state_do_0[11] assign, which is an e_assign
  internal_advance_to_state_do_0(11) <= internal_state_do_0(10);
  --advance_to_state_do_0[12] assign, which is an e_assign
  internal_advance_to_state_do_0(12) <= internal_state_do_0(11);
  --advance_to_state_do_0[13] assign, which is an e_assign
  internal_advance_to_state_do_0(13) <= internal_state_do_0(12);
  --advance_to_state_do_0[14] assign, which is an e_assign
  internal_advance_to_state_do_0(14) <= internal_state_do_0(13);
  --advance_to_state_do_0[15] assign, which is an e_assign
  internal_advance_to_state_do_0(15) <= internal_state_do_0(14);
  --advance_to_state_do_0[16] assign, which is an e_assign
  internal_advance_to_state_do_0(16) <= internal_state_do_0(15);
  --advance_to_state_do_0[17] assign, which is an e_assign
  internal_advance_to_state_do_0(17) <= internal_state_do_0(16);
  --advance_to_state_do_0[18] assign, which is an e_assign
  internal_advance_to_state_do_0(18) <= internal_state_do_0(17);
  --advance_to_state_do_0[19] assign, which is an e_assign
  internal_advance_to_state_do_0(19) <= internal_state_do_0(18);
  --on/inhibit register for c_do_block, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      inhibit_from_c_do_block1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if ((break34 AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_enable_state_do_0(19) AND internal_advance_to_state_do_0(19)))))))) /= std_logic_vector'("00000000000000000000000000000000") then 
        inhibit_from_c_do_block1 <= std_logic'('0');
      elsif ((go_bit_control_output3 AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((enable_state_do_2(1) AND advance_to_state_do_2(1)))))))) /= std_logic_vector'("00000000000000000000000000000000") then 
        inhibit_from_c_do_block1 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      end if;
    end if;

  end process;

  --block_wide_enable2 inhibitor mux, which is an e_mux
  block_wide_enable2 <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((NOT accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 OR NOT (internal_state_do_0(11)))) AND accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0) AND accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0)))) AND std_logic_vector'("00000000000000000000000000000001")));
  --vhdl renameroo for output signals
  advance_to_state_do_0 <= internal_advance_to_state_do_0;
  --vhdl renameroo for output signals
  enable_state_do_0 <= internal_enable_state_do_0;
  --vhdl renameroo for output signals
  state_do_0 <= internal_state_do_0;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_FIR_FIR_HW_master_resource0 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal go_bit_control_output7 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource0_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource0_write0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_master_resource0;


architecture europa of accelerator_FIR_FIR_HW_master_resource0 is
                signal accelerator_FIR_FIR_HW_master_resource0_address_mux_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource0_byteenable_mux_out0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource0_byteenable_shifted0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource0_writedata_mux_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 <= accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0;
  accelerator_FIR_FIR_HW_master_resource0_address_mux_out0 <= A_REP(((((enable_state_do_0(17) AND advance_to_state_do_0(17))) AND go_bit_control_output7(0))) , 32) AND accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2;
  --accelerator_FIR_FIR_HW_master_resource0 address register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_master_resource0_address0 <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_master_resource0_address0 <= accelerator_FIR_FIR_HW_master_resource0_address_mux_out0;
      end if;
    end if;

  end process;

  accelerator_FIR_FIR_HW_master_resource0_writedata_mux_out0 <= A_REP(((((enable_state_do_0(17) AND advance_to_state_do_0(17))) AND go_bit_control_output7(0))) , 32) AND accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0;
  --accelerator_FIR_FIR_HW_master_resource0 writedata register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_master_resource0_writedata0 <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_master_resource0_writedata0 <= accelerator_FIR_FIR_HW_master_resource0_writedata_mux_out0;
      end if;
    end if;

  end process;

  accelerator_FIR_FIR_HW_master_resource0_write0 <= accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0;
  accelerator_FIR_FIR_HW_master_resource0_byteenable_mux_out0 <= A_REP(((((enable_state_do_0(17) AND advance_to_state_do_0(17))) AND go_bit_control_output7(0))) , 4) AND std_logic_vector'("1111");
  accelerator_FIR_FIR_HW_master_resource0_byteenable_shifted0 <= accelerator_FIR_FIR_HW_master_resource0_byteenable_mux_out0;
  --accelerator_FIR_FIR_HW_master_resource0 byteenable register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_master_resource0_byteenable0 <= std_logic_vector'("0000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_master_resource0_byteenable0 <= accelerator_FIR_FIR_HW_master_resource0_byteenable_shifted0;
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_FIR_FIR_HW_master_resource1 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_readdata0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_fifo_out_aligned0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_flush0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_read0 : OUT STD_LOGIC
              );
end entity accelerator_FIR_FIR_HW_master_resource1;


architecture europa of accelerator_FIR_FIR_HW_master_resource1 is
  component scfifo is
GENERIC (
      lpm_numwords : NATURAL;
        lpm_showahead : STRING;
        lpm_width : NATURAL;
        lpm_widthu : NATURAL;
        use_eab : STRING
      );
    PORT (
    signal full : OUT STD_LOGIC;
        signal q : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
        signal empty : OUT STD_LOGIC;
        signal rdreq : IN STD_LOGIC;
        signal aclr : IN STD_LOGIC;
        signal data : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
        signal sclr : IN STD_LOGIC;
        signal clock : IN STD_LOGIC;
        signal wrreq : IN STD_LOGIC
      );
  end component scfifo;
                signal accelerator_FIR_FIR_HW_master_resource1_address_mux_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource1_fifo_aclr0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_master_resource1_fifo_full0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_master_resource1_fifo_out0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource1_fifo_read0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_master_resource1_fifo_sclr0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 :  STD_LOGIC;

begin

  accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 <= accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0;
  accelerator_FIR_FIR_HW_master_resource1_address_mux_out0 <= A_REP(((enable_state_do_0(2) AND advance_to_state_do_0(2))) , 32) AND accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2;
  --accelerator_FIR_FIR_HW_master_resource1 address register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_master_resource1_address0 <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_master_resource1_address0 <= accelerator_FIR_FIR_HW_master_resource1_address_mux_out0;
      end if;
    end if;

  end process;

  accelerator_FIR_FIR_HW_master_resource1_fifo_sclr0 <= enable_state_do_0(0) AND advance_to_state_do_0(0);
  accelerator_FIR_FIR_HW_master_resource1_fifo_aclr0 <= NOT reset_n;
  accelerator_FIR_FIR_HW_shift_fifo0 : scfifo
    generic map(
      lpm_numwords => 11,
      lpm_showahead => "ON",
      lpm_width => 16,
      lpm_widthu => 4,
      use_eab => "ON"
    )
    port map(
            aclr => accelerator_FIR_FIR_HW_master_resource1_fifo_aclr0,
            clock => clk,
            data => accelerator_FIR_FIR_HW_master_resource1_readdata0,
            empty => internal_accelerator_FIR_FIR_HW_master_resource1_fifo_empty0,
            full => accelerator_FIR_FIR_HW_master_resource1_fifo_full0,
            q => accelerator_FIR_FIR_HW_master_resource1_fifo_out0,
            rdreq => accelerator_FIR_FIR_HW_master_resource1_fifo_read0,
            sclr => accelerator_FIR_FIR_HW_master_resource1_fifo_sclr0,
            wrreq => accelerator_FIR_FIR_HW_master_resource1_readdatavalid0
    );

  accelerator_FIR_FIR_HW_master_resource1_flush0 <= enable_state_do_0(0) AND advance_to_state_do_0(0);
  accelerator_FIR_FIR_HW_master_resource1_read0 <= accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0;
  accelerator_FIR_FIR_HW_master_resource1_fifo_read0 <= enable_state_do_0(12) AND advance_to_state_do_0(12);
  accelerator_FIR_FIR_HW_master_resource1_fifo_out_aligned0 <= accelerator_FIR_FIR_HW_master_resource1_fifo_out0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 <= internal_accelerator_FIR_FIR_HW_master_resource1_fifo_empty0;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity accelerator_FIR_FIR_HW_registered_multiply0 is 
  port (
    -- inputs:
    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal clk : IN STD_LOGIC;
    signal enable : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;

    -- outputs:
    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
    );
end entity accelerator_FIR_FIR_HW_registered_multiply0;


architecture europa of accelerator_FIR_FIR_HW_registered_multiply0 is

  signal signed_product : signed (63 DOWNTO 0);
  signal a_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);
  signal b_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  signed_product <= signed(a_reg) * signed(b_reg);
  product <= std_logic_vector (signed_product);
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_reg <= std_logic_vector'("00000000000000000000000000000000");
      b_reg <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(enable) = '1' then 
        a_reg <= std_logic_vector'(a);
        b_reg <= std_logic_vector'(b);
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity accelerator_FIR_FIR_HW_registered_multiply1 is 
  port (
    -- inputs:
    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal clk : IN STD_LOGIC;
    signal enable : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;

    -- outputs:
    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
    );
end entity accelerator_FIR_FIR_HW_registered_multiply1;


architecture europa of accelerator_FIR_FIR_HW_registered_multiply1 is

  signal signed_product : signed (63 DOWNTO 0);
  signal a_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);
  signal b_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  signed_product <= signed(a_reg) * signed(b_reg);
  product <= std_logic_vector (signed_product);
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_reg <= std_logic_vector'("00000000000000000000000000000000");
      b_reg <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(enable) = '1' then 
        a_reg <= std_logic_vector'(a);
        b_reg <= std_logic_vector'(b);
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity accelerator_FIR_FIR_HW_registered_multiply2 is 
  port (
    -- inputs:
    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal clk : IN STD_LOGIC;
    signal enable : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;

    -- outputs:
    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
    );
end entity accelerator_FIR_FIR_HW_registered_multiply2;


architecture europa of accelerator_FIR_FIR_HW_registered_multiply2 is

  signal signed_product : signed (63 DOWNTO 0);
  signal a_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);
  signal b_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  signed_product <= signed(a_reg) * signed(b_reg);
  product <= std_logic_vector (signed_product);
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_reg <= std_logic_vector'("00000000000000000000000000000000");
      b_reg <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(enable) = '1' then 
        a_reg <= std_logic_vector'(a);
        b_reg <= std_logic_vector'(b);
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity accelerator_FIR_FIR_HW_registered_multiply3 is 
  port (
    -- inputs:
    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal clk : IN STD_LOGIC;
    signal enable : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;

    -- outputs:
    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
    );
end entity accelerator_FIR_FIR_HW_registered_multiply3;


architecture europa of accelerator_FIR_FIR_HW_registered_multiply3 is

  signal signed_product : signed (63 DOWNTO 0);
  signal a_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);
  signal b_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  signed_product <= signed(a_reg) * signed(b_reg);
  product <= std_logic_vector (signed_product);
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_reg <= std_logic_vector'("00000000000000000000000000000000");
      b_reg <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(enable) = '1' then 
        a_reg <= std_logic_vector'(a);
        b_reg <= std_logic_vector'(b);
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity accelerator_FIR_FIR_HW_registered_multiply4 is 
  port (
    -- inputs:
    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal clk : IN STD_LOGIC;
    signal enable : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;

    -- outputs:
    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
    );
end entity accelerator_FIR_FIR_HW_registered_multiply4;


architecture europa of accelerator_FIR_FIR_HW_registered_multiply4 is

  signal signed_product : signed (63 DOWNTO 0);
  signal a_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);
  signal b_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  signed_product <= signed(a_reg) * signed(b_reg);
  product <= std_logic_vector (signed_product);
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_reg <= std_logic_vector'("00000000000000000000000000000000");
      b_reg <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(enable) = '1' then 
        a_reg <= std_logic_vector'(a);
        b_reg <= std_logic_vector'(b);
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity accelerator_FIR_FIR_HW_registered_multiply5 is 
  port (
    -- inputs:
    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal clk : IN STD_LOGIC;
    signal enable : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;

    -- outputs:
    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
    );
end entity accelerator_FIR_FIR_HW_registered_multiply5;


architecture europa of accelerator_FIR_FIR_HW_registered_multiply5 is

  signal signed_product : signed (63 DOWNTO 0);
  signal a_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);
  signal b_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  signed_product <= signed(a_reg) * signed(b_reg);
  product <= std_logic_vector (signed_product);
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_reg <= std_logic_vector'("00000000000000000000000000000000");
      b_reg <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(enable) = '1' then 
        a_reg <= std_logic_vector'(a);
        b_reg <= std_logic_vector'(b);
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity accelerator_FIR_FIR_HW_registered_multiply6 is 
  port (
    -- inputs:
    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal clk : IN STD_LOGIC;
    signal enable : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;

    -- outputs:
    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
    );
end entity accelerator_FIR_FIR_HW_registered_multiply6;


architecture europa of accelerator_FIR_FIR_HW_registered_multiply6 is

  signal signed_product : signed (63 DOWNTO 0);
  signal a_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);
  signal b_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  signed_product <= signed(a_reg) * signed(b_reg);
  product <= std_logic_vector (signed_product);
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_reg <= std_logic_vector'("00000000000000000000000000000000");
      b_reg <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(enable) = '1' then 
        a_reg <= std_logic_vector'(a);
        b_reg <= std_logic_vector'(b);
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity accelerator_FIR_FIR_HW_registered_multiply7 is 
  port (
    -- inputs:
    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
    signal clk : IN STD_LOGIC;
    signal enable : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;

    -- outputs:
    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
    );
end entity accelerator_FIR_FIR_HW_registered_multiply7;


architecture europa of accelerator_FIR_FIR_HW_registered_multiply7 is

  signal signed_product : signed (63 DOWNTO 0);
  signal a_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);
  signal b_reg : STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  signed_product <= signed(a_reg) * signed(b_reg);
  product <= std_logic_vector (signed_product);
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_reg <= std_logic_vector'("00000000000000000000000000000000");
      b_reg <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(enable) = '1' then 
        a_reg <= std_logic_vector'(a);
        b_reg <= std_logic_vector'(b);
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

--c_pointer_dereference module for ../fir_hw.c:
--dataA = *input_data++;
--Connections: sdram_0/s1(64)
entity accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_module0 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 : OUT STD_LOGIC
              );
end entity accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_module0;


architecture europa of accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_module0 is

begin

  accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2 <= accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address1;
  --read is set by the previous state enable
  --and reset by no ~accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((enable_state_do_0(2) AND advance_to_state_do_0(2))) = '1' then 
        accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      elsif std_logic'(accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 <= std_logic'('0');
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

--c_pointer_dereference module for ../fir_hw.c:
--output_buffer[indexA] = adderA + adderB;
--Connections: accelerator_FIR_FIR_HW/accelerator_FIR_FIR_HW_output_buffer_internal_memory0_slave(1)
entity accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_module0 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal dereferenced_output_buffer_indexA_p3 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal enable_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal go_bit_control_output7 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_module0;


architecture europa of accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_module0 is

begin

  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2 <= accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address1;
  --write is set by the previous state enable
  --and reset by no ~accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((enable_state_do_0(17) AND advance_to_state_do_0(17))) AND go_bit_control_output7(0))) = '1' then 
        accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      elsif std_logic'(accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 <= std_logic'('0');
      end if;
    end if;

  end process;

  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0 <= dereferenced_output_buffer_indexA_p3;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- c_subroutine_block
--../fir_hw.c (138):     {
entity accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_2 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 : IN STD_LOGIC;
                 signal advance_to_state_do_2 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal break36 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal break48 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_2 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal go_bit_control_output9 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal advance_to_state_do_1 : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal enable_state_do_1 : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal inhibit_from_c_do_block2 : OUT STD_LOGIC;
                 signal state_do_1 : OUT STD_LOGIC_VECTOR (9 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_2;


architecture europa of accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_2 is
                signal block_wide_enable3 :  STD_LOGIC;
                signal internal_advance_to_state_do_1 :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_enable_state_do_1 :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_state_do_1 :  STD_LOGIC_VECTOR (9 DOWNTO 0);

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(0)) = '1' then 
        internal_state_do_1(0) <= internal_advance_to_state_do_1(0);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(0) <= block_wide_enable3;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(1)) = '1' then 
        internal_state_do_1(1) <= internal_advance_to_state_do_1(1);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(1) <= block_wide_enable3;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(2)) = '1' then 
        internal_state_do_1(2) <= internal_advance_to_state_do_1(2);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(2) <= block_wide_enable3;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(3)) = '1' then 
        internal_state_do_1(3) <= internal_advance_to_state_do_1(3);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(3) <= block_wide_enable3;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(4)) = '1' then 
        internal_state_do_1(4) <= internal_advance_to_state_do_1(4);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(4) <= block_wide_enable3;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(5) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(5)) = '1' then 
        internal_state_do_1(5) <= internal_advance_to_state_do_1(5);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(5) <= block_wide_enable3;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(6) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(6)) = '1' then 
        internal_state_do_1(6) <= internal_advance_to_state_do_1(6);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(6) <= block_wide_enable3;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(7) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(7)) = '1' then 
        internal_state_do_1(7) <= internal_advance_to_state_do_1(7);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(7) <= block_wide_enable3;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_1(8) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_1(8)) = '1' then 
        internal_state_do_1(8) <= internal_advance_to_state_do_1(8);
      end if;
    end if;

  end process;

  internal_enable_state_do_1(8) <= block_wide_enable3;
  internal_enable_state_do_1(9) <= block_wide_enable3;
  --advance_to_state_do_1[0] assign, which is an e_assign
  internal_advance_to_state_do_1(0) <= Vector_To_Std_Logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((enable_state_do_2(2) AND advance_to_state_do_2(2)))))) AND go_bit_control_output9) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(internal_state_do_1(0)))))));
  --advance_to_state_do_1[1] assign, which is an e_assign
  internal_advance_to_state_do_1(1) <= ((internal_state_do_1(0) OR internal_advance_to_state_do_1(2))) AND NOT((or_reduce(break36)));
  --advance_to_state_do_1[2] assign, which is an e_assign
  internal_advance_to_state_do_1(2) <= (internal_state_do_1(1)) AND NOT((or_reduce(break36)));
  --advance_to_state_do_1[3] assign, which is an e_assign
  internal_advance_to_state_do_1(3) <= internal_state_do_1(2);
  --advance_to_state_do_1[4] assign, which is an e_assign
  internal_advance_to_state_do_1(4) <= internal_state_do_1(3);
  --advance_to_state_do_1[5] assign, which is an e_assign
  internal_advance_to_state_do_1(5) <= internal_state_do_1(4);
  --advance_to_state_do_1[6] assign, which is an e_assign
  internal_advance_to_state_do_1(6) <= internal_state_do_1(5);
  --advance_to_state_do_1[7] assign, which is an e_assign
  internal_advance_to_state_do_1(7) <= internal_state_do_1(6);
  --advance_to_state_do_1[8] assign, which is an e_assign
  internal_advance_to_state_do_1(8) <= internal_state_do_1(7);
  --advance_to_state_do_1[9] assign, which is an e_assign
  internal_advance_to_state_do_1(9) <= internal_state_do_1(8);
  --on/inhibit register for c_do_block, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      inhibit_from_c_do_block2 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if ((break48 AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_enable_state_do_1(9) AND internal_advance_to_state_do_1(9)))))))) /= std_logic_vector'("00000000000000000000000000000000") then 
        inhibit_from_c_do_block2 <= std_logic'('0');
      elsif ((go_bit_control_output9 AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((enable_state_do_2(2) AND advance_to_state_do_2(2)))))))) /= std_logic_vector'("00000000000000000000000000000000") then 
        inhibit_from_c_do_block2 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      end if;
    end if;

  end process;

  --block_wide_enable3 inhibitor mux, which is an e_mux
  block_wide_enable3 <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((NOT accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 OR NOT (internal_state_do_1(4)))) AND accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0) AND accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0)))) AND std_logic_vector'("00000000000000000000000000000001")));
  --vhdl renameroo for output signals
  advance_to_state_do_1 <= internal_advance_to_state_do_1;
  --vhdl renameroo for output signals
  enable_state_do_1 <= internal_enable_state_do_1;
  --vhdl renameroo for output signals
  state_do_1 <= internal_state_do_1;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_FIR_FIR_HW_master_resource3 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal go_bit_control_output19 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource3_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource3_byteenable0 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource3_write0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource3_writedata0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_master_resource3;


architecture europa of accelerator_FIR_FIR_HW_master_resource3 is
                signal accelerator_FIR_FIR_HW_master_resource3_address_mux_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource3_byteenable_mux_out0 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource3_byteenable_shifted0 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource3_writedata_mux_out0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);

begin

  accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 <= accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0;
  accelerator_FIR_FIR_HW_master_resource3_address_mux_out0 <= A_REP(((((enable_state_do_1(7) AND advance_to_state_do_1(7))) AND go_bit_control_output19(0))) , 32) AND accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2;
  --accelerator_FIR_FIR_HW_master_resource3 address register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_master_resource3_address0 <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_master_resource3_address0 <= accelerator_FIR_FIR_HW_master_resource3_address_mux_out0;
      end if;
    end if;

  end process;

  accelerator_FIR_FIR_HW_master_resource3_writedata_mux_out0 <= A_REP(((((enable_state_do_1(7) AND advance_to_state_do_1(7))) AND go_bit_control_output19(0))) , 16) AND accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0;
  --accelerator_FIR_FIR_HW_master_resource3 writedata register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_master_resource3_writedata0 <= std_logic_vector'("0000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_master_resource3_writedata0 <= accelerator_FIR_FIR_HW_master_resource3_writedata_mux_out0;
      end if;
    end if;

  end process;

  accelerator_FIR_FIR_HW_master_resource3_write0 <= accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0;
  accelerator_FIR_FIR_HW_master_resource3_byteenable_mux_out0 <= A_REP(((((enable_state_do_1(7) AND advance_to_state_do_1(7))) AND go_bit_control_output19(0))) , 2) AND std_logic_vector'("11");
  accelerator_FIR_FIR_HW_master_resource3_byteenable_shifted0 <= accelerator_FIR_FIR_HW_master_resource3_byteenable_mux_out0;
  --accelerator_FIR_FIR_HW_master_resource3 byteenable register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_master_resource3_byteenable0 <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_master_resource3_byteenable0 <= accelerator_FIR_FIR_HW_master_resource3_byteenable_shifted0;
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_FIR_FIR_HW_master_resource2 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource2_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_fifo_out_aligned0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource2_flush0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_read0 : OUT STD_LOGIC
              );
end entity accelerator_FIR_FIR_HW_master_resource2;


architecture europa of accelerator_FIR_FIR_HW_master_resource2 is
  component scfifo is
GENERIC (
      lpm_numwords : NATURAL;
        lpm_showahead : STRING;
        lpm_width : NATURAL;
        lpm_widthu : NATURAL;
        use_eab : STRING
      );
    PORT (
    signal full : OUT STD_LOGIC;
        signal q : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
        signal empty : OUT STD_LOGIC;
        signal rdreq : IN STD_LOGIC;
        signal aclr : IN STD_LOGIC;
        signal data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
        signal sclr : IN STD_LOGIC;
        signal clock : IN STD_LOGIC;
        signal wrreq : IN STD_LOGIC
      );
  end component scfifo;
                signal accelerator_FIR_FIR_HW_master_resource2_address_mux_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource2_fifo_aclr0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_master_resource2_fifo_full0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_master_resource2_fifo_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource2_fifo_read0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_master_resource2_fifo_sclr0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 :  STD_LOGIC;

begin

  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 <= accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0;
  accelerator_FIR_FIR_HW_master_resource2_address_mux_out0 <= A_REP(((enable_state_do_1(2) AND advance_to_state_do_1(2))) , 32) AND accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2;
  --accelerator_FIR_FIR_HW_master_resource2 address register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_master_resource2_address0 <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_master_resource2_address0 <= accelerator_FIR_FIR_HW_master_resource2_address_mux_out0;
      end if;
    end if;

  end process;

  accelerator_FIR_FIR_HW_master_resource2_fifo_sclr0 <= enable_state_do_1(0) AND advance_to_state_do_1(0);
  accelerator_FIR_FIR_HW_master_resource2_fifo_aclr0 <= NOT reset_n;
  accelerator_FIR_FIR_HW_shift_fifo1 : scfifo
    generic map(
      lpm_numwords => 4,
      lpm_showahead => "ON",
      lpm_width => 32,
      lpm_widthu => 2,
      use_eab => "OFF"
    )
    port map(
            aclr => accelerator_FIR_FIR_HW_master_resource2_fifo_aclr0,
            clock => clk,
            data => accelerator_FIR_FIR_HW_master_resource2_readdata0,
            empty => internal_accelerator_FIR_FIR_HW_master_resource2_fifo_empty0,
            full => accelerator_FIR_FIR_HW_master_resource2_fifo_full0,
            q => accelerator_FIR_FIR_HW_master_resource2_fifo_out0,
            rdreq => accelerator_FIR_FIR_HW_master_resource2_fifo_read0,
            sclr => accelerator_FIR_FIR_HW_master_resource2_fifo_sclr0,
            wrreq => accelerator_FIR_FIR_HW_master_resource2_readdatavalid0
    );

  accelerator_FIR_FIR_HW_master_resource2_flush0 <= enable_state_do_1(0) AND advance_to_state_do_1(0);
  accelerator_FIR_FIR_HW_master_resource2_read0 <= accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0;
  accelerator_FIR_FIR_HW_master_resource2_fifo_read0 <= enable_state_do_1(5) AND advance_to_state_do_1(5);
  accelerator_FIR_FIR_HW_master_resource2_fifo_out_aligned0 <= accelerator_FIR_FIR_HW_master_resource2_fifo_out0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 <= internal_accelerator_FIR_FIR_HW_master_resource2_fifo_empty0;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

--c_pointer_dereference module for ../fir_hw.c:
--*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
--Connections: accelerator_FIR_FIR_HW/accelerator_FIR_FIR_HW_output_buffer_internal_memory0_slave(1)
entity accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_module0 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 : OUT STD_LOGIC
              );
end entity accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_module0;


architecture europa of accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_module0 is

begin

  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2 <= accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address1;
  --read is set by the previous state enable
  --and reset by no ~accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((enable_state_do_1(2) AND advance_to_state_do_1(2))) = '1' then 
        accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      elsif std_logic'(accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 <= std_logic'('0');
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

--c_pointer_dereference module for ../fir_hw.c:
--*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
--Connections: sdram_0/s1(64)
entity accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_module0 is 
        port (
              -- inputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal dereferenced_output_data2 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal enable_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal go_bit_control_output19 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_module0;


architecture europa of accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_module0 is

begin

  accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2 <= accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address1;
  --write is set by the previous state enable
  --and reset by no ~accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((enable_state_do_1(7) AND advance_to_state_do_1(7))) AND go_bit_control_output19(0))) = '1' then 
        accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      elsif std_logic'(accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0) = '1' then 
        accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 <= std_logic'('0');
      end if;
    end if;

  end process;

  accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0 <= dereferenced_output_data2;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_FIR_FIR_HW_FIR_HW0 is 
        port (
              -- inputs:
                 signal FIR_HW_begin0 : IN STD_LOGIC;
                 signal FIR_HW_functiondata0 : IN STD_LOGIC_VECTOR (239 DOWNTO 0);
                 signal FIR_HW_read0 : IN STD_LOGIC;
                 signal FIR_HW_select0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_readdata0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource2_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_base_address0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal FIR_HW_waitrequest_n0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource0_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource0_write0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_flush0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_read0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource2_flush0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_read0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource3_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource3_byteenable0 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource3_write0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource3_writedata0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cpu_readdata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity accelerator_FIR_FIR_HW_FIR_HW0;


architecture europa of accelerator_FIR_FIR_HW_FIR_HW0 is
component accelerator_FIR_FIR_HW_FIR_HW0_state_machine_subroutine_0 is 
           port (
                 -- inputs:
                    signal FIR_HW_begin0 : IN STD_LOGIC;
                    signal FIR_HW_read0 : IN STD_LOGIC;
                    signal FIR_HW_select0 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal inhibit_from_c_do_block0 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal FIR_HW_state0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal advance_to_FIR_HW_state0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal enable_FIR_HW_state0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_FIR_HW0_state_machine_subroutine_0;

component accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_0 is 
           port (
                 -- inputs:
                    signal advance_to_FIR_HW_state0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal break49 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal break50 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_FIR_HW_state0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal go_bit_control_output1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal inhibit_from_c_do_block1 : IN STD_LOGIC;
                    signal inhibit_from_c_do_block2 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal advance_to_state_do_2 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal enable_state_do_2 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal inhibit_from_c_do_block0 : OUT STD_LOGIC;
                    signal state_do_2 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_0;

component accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_1 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 : IN STD_LOGIC;
                    signal advance_to_state_do_2 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal break2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal break34 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_2 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal go_bit_control_output3 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal advance_to_state_do_0 : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal enable_state_do_0 : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal inhibit_from_c_do_block1 : OUT STD_LOGIC;
                    signal state_do_0 : OUT STD_LOGIC_VECTOR (19 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_1;

component accelerator_FIR_FIR_HW_master_resource0 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal go_bit_control_output7 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource0_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource0_write0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_master_resource0;

component accelerator_FIR_FIR_HW_master_resource1 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_readdata0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource1_readdatavalid0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_fifo_out_aligned0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource1_flush0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_read0 : OUT STD_LOGIC
                 );
end component accelerator_FIR_FIR_HW_master_resource1;

component accelerator_FIR_FIR_HW_registered_multiply0 is 
           port (
                 -- inputs:
                    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_registered_multiply0;

component accelerator_FIR_FIR_HW_registered_multiply1 is 
           port (
                 -- inputs:
                    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_registered_multiply1;

component accelerator_FIR_FIR_HW_registered_multiply2 is 
           port (
                 -- inputs:
                    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_registered_multiply2;

component accelerator_FIR_FIR_HW_registered_multiply3 is 
           port (
                 -- inputs:
                    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_registered_multiply3;

component accelerator_FIR_FIR_HW_registered_multiply4 is 
           port (
                 -- inputs:
                    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_registered_multiply4;

component accelerator_FIR_FIR_HW_registered_multiply5 is 
           port (
                 -- inputs:
                    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_registered_multiply5;

component accelerator_FIR_FIR_HW_registered_multiply6 is 
           port (
                 -- inputs:
                    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_registered_multiply6;

component accelerator_FIR_FIR_HW_registered_multiply7 is 
           port (
                 -- inputs:
                    signal a : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal b : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal product : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_registered_multiply7;

component accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_module0 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 : OUT STD_LOGIC
                 );
end component accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_module0;

component accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_module0 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal dereferenced_output_buffer_indexA_p3 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal enable_state_do_0 : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal go_bit_control_output7 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_module0;

component accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_2 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 : IN STD_LOGIC;
                    signal advance_to_state_do_2 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal break36 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal break48 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_2 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal go_bit_control_output9 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal advance_to_state_do_1 : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal enable_state_do_1 : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal inhibit_from_c_do_block2 : OUT STD_LOGIC;
                    signal state_do_1 : OUT STD_LOGIC_VECTOR (9 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_2;

component accelerator_FIR_FIR_HW_master_resource3 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal go_bit_control_output19 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource3_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource3_byteenable0 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource3_write0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource3_writedata0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_master_resource3;

component accelerator_FIR_FIR_HW_master_resource2 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource2_readdatavalid0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_fifo_out_aligned0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource2_flush0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_read0 : OUT STD_LOGIC
                 );
end component accelerator_FIR_FIR_HW_master_resource2;

component accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_module0 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 : OUT STD_LOGIC
                 );
end component accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_module0;

component accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_module0 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal dereferenced_output_data2 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal enable_state_do_1 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal go_bit_control_output19 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_module0;

                signal FIR_HW_state0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p3_read0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p4_read0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p5_read0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_master_resource1_fifo_out_aligned0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 :  STD_LOGIC;
                signal accelerator_FIR_FIR_HW_master_resource2_fifo_out_aligned0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource0_op_a0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource0_op_b0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource0_res0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource1_op_a0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource1_op_b0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource1_res0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource2_op_a0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource2_op_b0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource2_res0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource3_op_a0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource3_op_b0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource3_res0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource4_op_a0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource4_op_b0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource4_res0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource5_op_a0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource5_op_b0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource5_res0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource6_op_a0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource6_op_b0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource6_res0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource7_op_a0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource7_op_b0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_multiplier_resource7_res0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal adderA0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal adderA1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal adderA2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal adderA3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal adderB0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal adderB1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal adderB2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal adderB3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal advance_to_FIR_HW_state0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal advance_to_state_do_0 :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal advance_to_state_do_1 :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal advance_to_state_do_2 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal break0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break17 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break18 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break19 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break20 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break21 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break22 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break23 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break24 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break25 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break26 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break27 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break28 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break29 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break30 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break31 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break32 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break33 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break34 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break35 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break36 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break37 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break38 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break39 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break40 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break41 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break42 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break43 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break44 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break45 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break46 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break47 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break48 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break49 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break50 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal coefA0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefB0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefC0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefD0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefE0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefF0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefG0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefH0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal continue0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal continue1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal continue2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal control_output_break1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal control_output_break3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal control_output_break5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dataA0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataA_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataB_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataC_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataD_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataE_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataF_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataG_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataH_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataI_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataJ_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataK_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataL_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataM_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataN_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataO_init3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataP0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataP1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataP2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataP3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataP4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dataP5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dereferenced_input_data2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dereferenced_output_buffer_indexA_p3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dereferenced_output_buffer_indexB_p3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dereferenced_output_buffer_indexB_p4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dereferenced_output_buffer_indexB_p5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dereferenced_output_buffer_indexB_p6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dereferenced_output_data2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal divide_order0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal enable_FIR_HW_state0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal enable_state_do_0 :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal enable_state_do_1 :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal enable_state_do_2 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal first_time_at_clock_0_state_do_1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal first_time_at_clock_0_state_do_4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal first_time_at_clock_11_state_do_1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal first_time_at_clock_12_state_do_1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal first_time_at_clock_17_state_do_1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal first_time_at_clock_2_state_do_3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal first_time_at_clock_3_state_do_3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal first_time_at_clock_7_state_do_2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal go_bit_control_output1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal go_bit_control_output19 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal go_bit_control_output3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal go_bit_control_output7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal go_bit_control_output9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if17 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if18 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if19 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if20 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if21 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if22 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if23 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal indexA0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA10 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA11 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA12 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA13 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA14 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA15 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA16 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA17 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA18 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA19 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA20 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA21 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA22 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA23 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexA_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB10 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB11 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB12 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB2 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB3 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB4 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB5 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB6 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB7 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB8 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB9 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal indexB_init1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal inhibit_from_c_do_block0 :  STD_LOGIC;
                signal inhibit_from_c_do_block1 :  STD_LOGIC;
                signal inhibit_from_c_do_block2 :  STD_LOGIC;
                signal input_data0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data17 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data18 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data19 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data20 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data21 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data22 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data_init1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal input_data_init3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource0_byteenable1 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource0_write1 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource0_writedata1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource1_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource1_flush1 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource1_read1 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource2_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource2_flush1 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource2_read1 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource3_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource3_byteenable1 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource3_write1 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource3_writedata1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal length0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length_init1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length_init3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal lpm_mult_clken0 :  STD_LOGIC;
                signal lpm_mult_clken1 :  STD_LOGIC;
                signal lpm_mult_clken2 :  STD_LOGIC;
                signal lpm_mult_clken3 :  STD_LOGIC;
                signal lpm_mult_clken4 :  STD_LOGIC;
                signal lpm_mult_clken5 :  STD_LOGIC;
                signal lpm_mult_clken6 :  STD_LOGIC;
                signal lpm_mult_clken7 :  STD_LOGIC;
                signal lpm_multiply_result0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal lpm_multiply_result1 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal lpm_multiply_result2 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal lpm_multiply_result3 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal lpm_multiply_result4 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal lpm_multiply_result5 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal lpm_multiply_result6 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal lpm_multiply_result7 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal multiply1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment0_op_a1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment0_op_a2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment0_op_b1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment0_op_b2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment0_prod0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal multiply_assignment1_op_a1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment1_op_a2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment1_op_b1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment1_op_b2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment1_prod0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal multiply_assignment2_op_a1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment2_op_a2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment2_op_b1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment2_op_b2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment2_prod0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal multiply_assignment3_op_a1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment3_op_a2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment3_op_b1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment3_op_b2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment3_prod0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal multiply_assignment4_op_a1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment4_op_a2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment4_op_b1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment4_op_b2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment4_prod0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal multiply_assignment5_op_a1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment5_op_a2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment5_op_b1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment5_op_b2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment5_prod0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal multiply_assignment6_op_a1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment6_op_a2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment6_op_b1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment6_op_b2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment6_prod0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal multiply_assignment7_op_a1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment7_op_a2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment7_op_b1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment7_op_b2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal multiply_assignment7_prod0 :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal output_buffer0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data_init1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data_init3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal return0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal state_do_0 :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal state_do_1 :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal state_do_2 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal subexp0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp14 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal subexp15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp17 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp18 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp19 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp20 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp21 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp22 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp23 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp24 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp25 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp26 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp27 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp28 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp29 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp30 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp31 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp32 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp33 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp34 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp35 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp36 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp37 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp38 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp39 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp40 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp41 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp42 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp43 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp44 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp45 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp46 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp47 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp48 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal subexp49 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp50 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp51 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp52 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp53 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp54 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp55 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp56 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp57 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp58 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp59 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp60 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp61 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp62 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp63 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp64 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp65 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tap_length0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal termA0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termA1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termA2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termA3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termB0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termB1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termB2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termB3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termC0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termC1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termC2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termC3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termD0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termD1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termD2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termD3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termE0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termE1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termE2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termE3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termF0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termF1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termF2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termF3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termG0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termG1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termG2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termG3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termH0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termH1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termH2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal termH3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  FIR_HW_waitrequest_n0 <= enable_FIR_HW_state0(3) AND advance_to_FIR_HW_state0(3);
  --c_subroutine_block
  accelerator_FIR_FIR_HW_FIR_HW0_the_state_machine_subroutine_0 : accelerator_FIR_FIR_HW_FIR_HW0_state_machine_subroutine_0
    port map(
      FIR_HW_state0 => FIR_HW_state0,
      advance_to_FIR_HW_state0 => advance_to_FIR_HW_state0,
      enable_FIR_HW_state0 => enable_FIR_HW_state0,
      FIR_HW_begin0 => FIR_HW_begin0,
      FIR_HW_read0 => FIR_HW_read0,
      FIR_HW_select0 => FIR_HW_select0,
      clk => clk,
      inhibit_from_c_do_block0 => inhibit_from_c_do_block0,
      reset_n => reset_n
    );


  adderA0 <= std_logic_vector'("00000000000000000000000000000000");
  adderB0 <= std_logic_vector'("00000000000000000000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataA = 0;
  dataA1 <= std_logic_vector'("0000000000000000");
  dataA0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataB = 0;
  dataB1 <= std_logic_vector'("0000000000000000");
  dataB0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataC = 0;
  dataC1 <= std_logic_vector'("0000000000000000");
  dataC0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataD = 0;
  dataD1 <= std_logic_vector'("0000000000000000");
  dataD0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataE = 0;
  dataE1 <= std_logic_vector'("0000000000000000");
  dataE0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataF = 0;
  dataF1 <= std_logic_vector'("0000000000000000");
  dataF0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataG = 0;
  dataG1 <= std_logic_vector'("0000000000000000");
  dataG0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataH = 0;
  dataH1 <= std_logic_vector'("0000000000000000");
  dataH0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataI = 0;
  dataI1 <= std_logic_vector'("0000000000000000");
  dataI0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataJ = 0;
  dataJ1 <= std_logic_vector'("0000000000000000");
  dataJ0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataK = 0;
  dataK1 <= std_logic_vector'("0000000000000000");
  dataK0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataL = 0;
  dataL1 <= std_logic_vector'("0000000000000000");
  dataL0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataM = 0;
  dataM1 <= std_logic_vector'("0000000000000000");
  dataM0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataN = 0;
  dataN1 <= std_logic_vector'("0000000000000000");
  dataN0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataO = 0;
  dataO1 <= std_logic_vector'("0000000000000000");
  dataO0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --dataP = 0;
  dataP1 <= std_logic_vector'("0000000000000000");
  dataP0 <= std_logic_vector'("0000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --void FIR_HW(short * input_data,
  if0 <= std_logic_vector'("00000000000000000000000000000001");
  indexA0 <= std_logic_vector'("0000000000000000");
  indexB0 <= std_logic_vector'("0000000000000000");
  output_buffer0 <= accelerator_FIR_FIR_HW_output_buffer_internal_memory0_base_address0;
  -- e_assignment on clock 0 for ../fir_hw.c:
  --void FIR_HW(short * input_data,
  return0 <= std_logic_vector'("00000000000000000000000000000000");
  termA0 <= std_logic_vector'("00000000000000000000000000000000");
  termB0 <= std_logic_vector'("00000000000000000000000000000000");
  termC0 <= std_logic_vector'("00000000000000000000000000000000");
  termD0 <= std_logic_vector'("00000000000000000000000000000000");
  termE0 <= std_logic_vector'("00000000000000000000000000000000");
  termF0 <= std_logic_vector'("00000000000000000000000000000000");
  termG0 <= std_logic_vector'("00000000000000000000000000000000");
  termH0 <= std_logic_vector'("00000000000000000000000000000000");
  (input_data0(31), input_data0(30), input_data0(29), input_data0(28), input_data0(27), input_data0(26), input_data0(25), input_data0(24), input_data0(23), input_data0(22), input_data0(21), input_data0(20), input_data0(19), input_data0(18), input_data0(17), input_data0(16), input_data0(15), input_data0(14), input_data0(13), input_data0(12), input_data0(11), input_data0(10), input_data0(9), input_data0(8), input_data0(7), input_data0(6), input_data0(5), input_data0(4), input_data0(3), input_data0(2), input_data0(1), input_data0(0), length0(31), length0(30), length0(29), length0(28), length0(27), length0(26), length0(25), length0(24), length0(23), length0(22), length0(21), length0(20), length0(19), length0(18), length0(17), length0(16), length0(15), length0(14), length0(13), length0(12), length0(11), length0(10), length0(9), length0(8), length0(7), length0(6), length0(5), length0(4), length0(3), length0(2), length0(1), length0(0), output_data0(31), output_data0(30), output_data0(29), output_data0(28), output_data0(27), output_data0(26), output_data0(25), output_data0(24), output_data0(23), output_data0(22), output_data0(21), output_data0(20), output_data0(19), output_data0(18), output_data0(17), output_data0(16), output_data0(15), output_data0(14), output_data0(13), output_data0(12), output_data0(11), output_data0(10), output_data0(9), output_data0(8), output_data0(7), output_data0(6), output_data0(5), output_data0(4), output_data0(3), output_data0(2), output_data0(1), output_data0(0), tap_length0(7), tap_length0(6), tap_length0(5), tap_length0(4), tap_length0(3), tap_length0(2), tap_length0(1), tap_length0(0), coefA0(15), coefA0(14), coefA0(13), coefA0(12), coefA0(11), coefA0(10), coefA0(9), coefA0(8), coefA0(7), coefA0(6), coefA0(5), coefA0(4), coefA0(3), coefA0(2), coefA0(1), coefA0(0), coefB0(15), coefB0(14), coefB0(13), coefB0(12), coefB0(11), coefB0(10), coefB0(9), coefB0(8), coefB0(7), coefB0(6), coefB0(5), coefB0(4), coefB0(3), coefB0(2), coefB0(1), coefB0(0), coefC0(15), coefC0(14), coefC0(13), coefC0(12), coefC0(11), coefC0(10), coefC0(9), coefC0(8), coefC0(7), coefC0(6), coefC0(5), coefC0(4), coefC0(3), coefC0(2), coefC0(1), coefC0(0), coefD0(15), coefD0(14), coefD0(13), coefD0(12), coefD0(11), coefD0(10), coefD0(9), coefD0(8), coefD0(7), coefD0(6), coefD0(5), coefD0(4), coefD0(3), coefD0(2), coefD0(1), coefD0(0), coefE0(15), coefE0(14), coefE0(13), coefE0(12), coefE0(11), coefE0(10), coefE0(9), coefE0(8), coefE0(7), coefE0(6), coefE0(5), coefE0(4), coefE0(3), coefE0(2), coefE0(1), coefE0(0), coefF0(15), coefF0(14), coefF0(13), coefF0(12), coefF0(11), coefF0(10), coefF0(9), coefF0(8), coefF0(7), coefF0(6), coefF0(5), coefF0(4), coefF0(3), coefF0(2), coefF0(1), coefF0(0), coefG0(15), coefG0(14), coefG0(13), coefG0(12), coefG0(11), coefG0(10), coefG0(9), coefG0(8), coefG0(7), coefG0(6), coefG0(5), coefG0(4), coefG0(3), coefG0(2), coefG0(1), coefG0(0), coefH0(15), coefH0(14), coefH0(13), coefH0(12), coefH0(11), coefH0(10), coefH0(9), coefH0(8), coefH0(7), coefH0(6), coefH0(5), coefH0(4), coefH0(3), coefH0(2), coefH0(1), coefH0(0), divide_order0(7), divide_order0(6), divide_order0(5), divide_order0(4), divide_order0(3), divide_order0(2), divide_order0(1), divide_order0(0)) <= FIR_HW_functiondata0;
  subexp0 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return0))));
  subexp1 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp0) AND or_reduce(if0))));
  -- e_assignment on clock 0 for ../fir_hw.c:
  --{
  go_bit_control_output1 <= subexp1;
  --c_do_block
  accelerator_FIR_FIR_HW_FIR_HW0_the_state_machine_do_0 : accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_0
    port map(
      advance_to_state_do_2 => advance_to_state_do_2,
      enable_state_do_2 => enable_state_do_2,
      inhibit_from_c_do_block0 => inhibit_from_c_do_block0,
      state_do_2 => state_do_2,
      advance_to_FIR_HW_state0 => advance_to_FIR_HW_state0,
      break49 => break49,
      break50 => break50,
      clk => clk,
      enable_FIR_HW_state0 => enable_FIR_HW_state0,
      go_bit_control_output1 => go_bit_control_output1,
      inhibit_from_c_do_block1 => inhibit_from_c_do_block1,
      inhibit_from_c_do_block2 => inhibit_from_c_do_block2,
      reset_n => reset_n
    );


  dataA_init3 <= dataA1;
  dataB_init3 <= dataB1;
  dataC_init3 <= dataC1;
  dataD_init3 <= dataD1;
  dataE_init3 <= dataE1;
  dataF_init3 <= dataF1;
  dataG_init3 <= dataG1;
  dataH_init3 <= dataH1;
  dataI_init3 <= dataI1;
  dataJ_init3 <= dataJ1;
  dataK_init3 <= dataK1;
  dataL_init3 <= dataL1;
  dataM_init3 <= dataM1;
  dataN_init3 <= dataN1;
  dataO_init3 <= dataO1;
  input_data_init3 <= input_data0;
  length_init3 <= length0;
  output_data_init3 <= output_data0;
  -- e_assignment on clock 0 for ../fir_hw.c:
  --{
  break0 <= std_logic_vector'("00000000000000000000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --{
  continue0 <= std_logic_vector'("00000000000000000000000000000000");
  -- e_assignment on clock 0 for ../fir_hw.c:
  --{
  if1 <= std_logic_vector'("00000000000000000000000000000001");
  subexp2 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return0))));
  subexp3 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(continue0))));
  subexp4 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(break0))));
  subexp5 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp3) AND or_reduce(subexp4))));
  subexp6 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(if1) AND or_reduce(subexp5))));
  subexp7 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp2) AND or_reduce(subexp6))));
  -- e_assignment on clock 0 for ../fir_hw.c:
  --{
  go_bit_control_output3 <= subexp7;
  dataA8 <= dataA7;
  dataB8 <= dataB7;
  dataC8 <= dataC7;
  dataD8 <= dataD7;
  dataE8 <= dataE7;
  dataF8 <= dataF7;
  dataG8 <= dataG7;
  dataH8 <= dataH7;
  dataI7 <= dataI6;
  dataJ8 <= dataJ7;
  dataK8 <= dataK7;
  dataL8 <= dataL7;
  dataM8 <= dataM7;
  dataN8 <= dataN7;
  dataO8 <= dataO7;
  -- e_assignment on clock 1 for ../fir_hw.c:
  --indexA = 0;
  indexA1 <= std_logic_vector'("0000000000000000");
  input_data21 <= input_data20;
  length7 <= length6;
  subexp8 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return0))));
  subexp9 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(continue0))));
  subexp10 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(break0))));
  subexp11 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp9) AND or_reduce(subexp10))));
  subexp12 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(if1) AND or_reduce(subexp11))));
  subexp13 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp8) AND or_reduce(subexp12))));
  -- e_assignment on clock 1 for ../fir_hw.c:
  --{
  go_bit_control_output9 <= subexp13;
  --c_do_block
  accelerator_FIR_FIR_HW_FIR_HW0_the_state_machine_do_1 : accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_1
    port map(
      advance_to_state_do_0 => advance_to_state_do_0,
      enable_state_do_0 => enable_state_do_0,
      inhibit_from_c_do_block1 => inhibit_from_c_do_block1,
      state_do_0 => state_do_0,
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 => accelerator_FIR_FIR_HW_master_resource1_fifo_empty0,
      advance_to_state_do_2 => advance_to_state_do_2,
      break2 => break2,
      break34 => break34,
      clk => clk,
      enable_state_do_2 => enable_state_do_2,
      go_bit_control_output3 => go_bit_control_output3,
      reset_n => reset_n
    );


  dataA_init1 <= dataA8;
  dataB_init1 <= dataB8;
  dataC_init1 <= dataC8;
  dataD_init1 <= dataD8;
  dataE_init1 <= dataE8;
  dataF_init1 <= dataF8;
  dataG_init1 <= dataG8;
  dataH_init1 <= dataH8;
  dataI_init1 <= dataI7;
  dataJ_init1 <= dataJ8;
  dataK_init1 <= dataK8;
  dataL_init1 <= dataL8;
  dataM_init1 <= dataM8;
  dataN_init1 <= dataN8;
  dataO_init1 <= dataO8;
  indexA_init1 <= indexA1;
  input_data_init1 <= input_data21;
  length_init1 <= length7;
  --the_accelerator_FIR_FIR_HW_master_resource0, which is an e_instance
  the_accelerator_FIR_FIR_HW_master_resource0 : accelerator_FIR_FIR_HW_master_resource0
    port map(
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource0_address0 => internal_accelerator_FIR_FIR_HW_master_resource0_address1,
      accelerator_FIR_FIR_HW_master_resource0_byteenable0 => internal_accelerator_FIR_FIR_HW_master_resource0_byteenable1,
      accelerator_FIR_FIR_HW_master_resource0_write0 => internal_accelerator_FIR_FIR_HW_master_resource0_write1,
      accelerator_FIR_FIR_HW_master_resource0_writedata0 => internal_accelerator_FIR_FIR_HW_master_resource0_writedata1,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0,
      accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0 => accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0,
      advance_to_state_do_0 => advance_to_state_do_0,
      clk => clk,
      enable_state_do_0 => enable_state_do_0,
      go_bit_control_output7 => go_bit_control_output7,
      reset_n => reset_n
    );


  --the_accelerator_FIR_FIR_HW_master_resource1, which is an e_instance
  the_accelerator_FIR_FIR_HW_master_resource1 : accelerator_FIR_FIR_HW_master_resource1
    port map(
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource1_address0 => internal_accelerator_FIR_FIR_HW_master_resource1_address1,
      accelerator_FIR_FIR_HW_master_resource1_fifo_empty0 => accelerator_FIR_FIR_HW_master_resource1_fifo_empty0,
      accelerator_FIR_FIR_HW_master_resource1_fifo_out_aligned0 => accelerator_FIR_FIR_HW_master_resource1_fifo_out_aligned0,
      accelerator_FIR_FIR_HW_master_resource1_flush0 => internal_accelerator_FIR_FIR_HW_master_resource1_flush1,
      accelerator_FIR_FIR_HW_master_resource1_read0 => internal_accelerator_FIR_FIR_HW_master_resource1_read1,
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2 => accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2,
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 => accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0,
      accelerator_FIR_FIR_HW_master_resource1_readdata0 => accelerator_FIR_FIR_HW_master_resource1_readdata0,
      accelerator_FIR_FIR_HW_master_resource1_readdatavalid0 => accelerator_FIR_FIR_HW_master_resource1_readdatavalid0,
      accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0 => accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0,
      advance_to_state_do_0 => advance_to_state_do_0,
      clk => clk,
      enable_state_do_0 => enable_state_do_0,
      reset_n => reset_n
    );


  multiply_assignment0_prod0 <= accelerator_FIR_FIR_HW_multiplier_resource0_res0;
  accelerator_FIR_FIR_HW_multiplier_resource0_op_a0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment0_op_a2;
  accelerator_FIR_FIR_HW_multiplier_resource0_op_b0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment0_op_b2;
  lpm_mult_clken0 <= ((enable_state_do_0(13) AND advance_to_state_do_0(13))) OR ((enable_state_do_0(14) AND advance_to_state_do_0(14)));
  accelerator_FIR_FIR_HW_multiplier_resource0_res0 <= std_logic_vector'("00000000000000000000000000000000") & (lpm_multiply_result0(31 DOWNTO 0));
  --the_accelerator_FIR_FIR_HW_registered_multiply0, which is an e_instance
  the_accelerator_FIR_FIR_HW_registered_multiply0 : accelerator_FIR_FIR_HW_registered_multiply0
    port map(
      product => lpm_multiply_result0,
      a => accelerator_FIR_FIR_HW_multiplier_resource0_op_a0,
      b => accelerator_FIR_FIR_HW_multiplier_resource0_op_b0,
      clk => clk,
      enable => lpm_mult_clken0,
      reset_n => reset_n
    );


  multiply_assignment7_prod0 <= accelerator_FIR_FIR_HW_multiplier_resource1_res0;
  accelerator_FIR_FIR_HW_multiplier_resource1_op_a0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment7_op_a2;
  accelerator_FIR_FIR_HW_multiplier_resource1_op_b0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment7_op_b2;
  lpm_mult_clken1 <= ((enable_state_do_0(13) AND advance_to_state_do_0(13))) OR ((enable_state_do_0(14) AND advance_to_state_do_0(14)));
  accelerator_FIR_FIR_HW_multiplier_resource1_res0 <= std_logic_vector'("00000000000000000000000000000000") & (lpm_multiply_result1(31 DOWNTO 0));
  --the_accelerator_FIR_FIR_HW_registered_multiply1, which is an e_instance
  the_accelerator_FIR_FIR_HW_registered_multiply1 : accelerator_FIR_FIR_HW_registered_multiply1
    port map(
      product => lpm_multiply_result1,
      a => accelerator_FIR_FIR_HW_multiplier_resource1_op_a0,
      b => accelerator_FIR_FIR_HW_multiplier_resource1_op_b0,
      clk => clk,
      enable => lpm_mult_clken1,
      reset_n => reset_n
    );


  multiply_assignment6_prod0 <= accelerator_FIR_FIR_HW_multiplier_resource2_res0;
  accelerator_FIR_FIR_HW_multiplier_resource2_op_a0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment6_op_a2;
  accelerator_FIR_FIR_HW_multiplier_resource2_op_b0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment6_op_b2;
  lpm_mult_clken2 <= ((enable_state_do_0(13) AND advance_to_state_do_0(13))) OR ((enable_state_do_0(14) AND advance_to_state_do_0(14)));
  accelerator_FIR_FIR_HW_multiplier_resource2_res0 <= std_logic_vector'("00000000000000000000000000000000") & (lpm_multiply_result2(31 DOWNTO 0));
  --the_accelerator_FIR_FIR_HW_registered_multiply2, which is an e_instance
  the_accelerator_FIR_FIR_HW_registered_multiply2 : accelerator_FIR_FIR_HW_registered_multiply2
    port map(
      product => lpm_multiply_result2,
      a => accelerator_FIR_FIR_HW_multiplier_resource2_op_a0,
      b => accelerator_FIR_FIR_HW_multiplier_resource2_op_b0,
      clk => clk,
      enable => lpm_mult_clken2,
      reset_n => reset_n
    );


  multiply_assignment2_prod0 <= accelerator_FIR_FIR_HW_multiplier_resource6_res0;
  accelerator_FIR_FIR_HW_multiplier_resource6_op_a0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment2_op_a2;
  accelerator_FIR_FIR_HW_multiplier_resource6_op_b0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment2_op_b2;
  lpm_mult_clken3 <= ((enable_state_do_0(13) AND advance_to_state_do_0(13))) OR ((enable_state_do_0(14) AND advance_to_state_do_0(14)));
  accelerator_FIR_FIR_HW_multiplier_resource6_res0 <= std_logic_vector'("00000000000000000000000000000000") & (lpm_multiply_result3(31 DOWNTO 0));
  --the_accelerator_FIR_FIR_HW_registered_multiply3, which is an e_instance
  the_accelerator_FIR_FIR_HW_registered_multiply3 : accelerator_FIR_FIR_HW_registered_multiply3
    port map(
      product => lpm_multiply_result3,
      a => accelerator_FIR_FIR_HW_multiplier_resource6_op_a0,
      b => accelerator_FIR_FIR_HW_multiplier_resource6_op_b0,
      clk => clk,
      enable => lpm_mult_clken3,
      reset_n => reset_n
    );


  multiply_assignment5_prod0 <= accelerator_FIR_FIR_HW_multiplier_resource3_res0;
  accelerator_FIR_FIR_HW_multiplier_resource3_op_a0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment5_op_a2;
  accelerator_FIR_FIR_HW_multiplier_resource3_op_b0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment5_op_b2;
  lpm_mult_clken4 <= ((enable_state_do_0(13) AND advance_to_state_do_0(13))) OR ((enable_state_do_0(14) AND advance_to_state_do_0(14)));
  accelerator_FIR_FIR_HW_multiplier_resource3_res0 <= std_logic_vector'("00000000000000000000000000000000") & (lpm_multiply_result4(31 DOWNTO 0));
  --the_accelerator_FIR_FIR_HW_registered_multiply4, which is an e_instance
  the_accelerator_FIR_FIR_HW_registered_multiply4 : accelerator_FIR_FIR_HW_registered_multiply4
    port map(
      product => lpm_multiply_result4,
      a => accelerator_FIR_FIR_HW_multiplier_resource3_op_a0,
      b => accelerator_FIR_FIR_HW_multiplier_resource3_op_b0,
      clk => clk,
      enable => lpm_mult_clken4,
      reset_n => reset_n
    );


  multiply_assignment1_prod0 <= accelerator_FIR_FIR_HW_multiplier_resource7_res0;
  accelerator_FIR_FIR_HW_multiplier_resource7_op_a0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment1_op_a2;
  accelerator_FIR_FIR_HW_multiplier_resource7_op_b0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment1_op_b2;
  lpm_mult_clken5 <= ((enable_state_do_0(13) AND advance_to_state_do_0(13))) OR ((enable_state_do_0(14) AND advance_to_state_do_0(14)));
  accelerator_FIR_FIR_HW_multiplier_resource7_res0 <= std_logic_vector'("00000000000000000000000000000000") & (lpm_multiply_result5(31 DOWNTO 0));
  --the_accelerator_FIR_FIR_HW_registered_multiply5, which is an e_instance
  the_accelerator_FIR_FIR_HW_registered_multiply5 : accelerator_FIR_FIR_HW_registered_multiply5
    port map(
      product => lpm_multiply_result5,
      a => accelerator_FIR_FIR_HW_multiplier_resource7_op_a0,
      b => accelerator_FIR_FIR_HW_multiplier_resource7_op_b0,
      clk => clk,
      enable => lpm_mult_clken5,
      reset_n => reset_n
    );


  multiply_assignment4_prod0 <= accelerator_FIR_FIR_HW_multiplier_resource4_res0;
  accelerator_FIR_FIR_HW_multiplier_resource4_op_a0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment4_op_a2;
  accelerator_FIR_FIR_HW_multiplier_resource4_op_b0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment4_op_b2;
  lpm_mult_clken6 <= ((enable_state_do_0(13) AND advance_to_state_do_0(13))) OR ((enable_state_do_0(14) AND advance_to_state_do_0(14)));
  accelerator_FIR_FIR_HW_multiplier_resource4_res0 <= std_logic_vector'("00000000000000000000000000000000") & (lpm_multiply_result6(31 DOWNTO 0));
  --the_accelerator_FIR_FIR_HW_registered_multiply6, which is an e_instance
  the_accelerator_FIR_FIR_HW_registered_multiply6 : accelerator_FIR_FIR_HW_registered_multiply6
    port map(
      product => lpm_multiply_result6,
      a => accelerator_FIR_FIR_HW_multiplier_resource4_op_a0,
      b => accelerator_FIR_FIR_HW_multiplier_resource4_op_b0,
      clk => clk,
      enable => lpm_mult_clken6,
      reset_n => reset_n
    );


  multiply_assignment3_prod0 <= accelerator_FIR_FIR_HW_multiplier_resource5_res0;
  accelerator_FIR_FIR_HW_multiplier_resource5_op_a0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment3_op_a2;
  accelerator_FIR_FIR_HW_multiplier_resource5_op_b0 <= A_REP(((enable_state_do_0(13) AND advance_to_state_do_0(13))) , 32) AND multiply_assignment3_op_b2;
  lpm_mult_clken7 <= ((enable_state_do_0(13) AND advance_to_state_do_0(13))) OR ((enable_state_do_0(14) AND advance_to_state_do_0(14)));
  accelerator_FIR_FIR_HW_multiplier_resource5_res0 <= std_logic_vector'("00000000000000000000000000000000") & (lpm_multiply_result7(31 DOWNTO 0));
  --the_accelerator_FIR_FIR_HW_registered_multiply7, which is an e_instance
  the_accelerator_FIR_FIR_HW_registered_multiply7 : accelerator_FIR_FIR_HW_registered_multiply7
    port map(
      product => lpm_multiply_result7,
      a => accelerator_FIR_FIR_HW_multiplier_resource5_op_a0,
      b => accelerator_FIR_FIR_HW_multiplier_resource5_op_b0,
      clk => clk,
      enable => lpm_mult_clken7,
      reset_n => reset_n
    );


  indexA4 <= indexA3;
  input_data4 <= input_data3;
  length3 <= length2;
  subexp14 <= A_EXT (((std_logic_vector'("00000000000000000") & (indexA4)) + std_logic_vector'("000000000000000000000000000000001")), 16);
  subexp15 <= A_EXT (((std_logic_vector'("0") & (input_data4)) + std_logic_vector'("000000000000000000000000000000010")), 32);
  subexp16 <= A_EXT (((std_logic_vector'("0") & (length3)) - std_logic_vector'("000000000000000000000000000000001")), 32);
  -- e_assignment on clock 1 for ../fir_hw.c:
  --dataA = *input_data++;
  accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address1 <= input_data17;
  -- e_assignment on clock 1 for ../fir_hw.c:
  --{
  break1 <= std_logic_vector'("00000000000000000000000000000000");
  signal0 <= std_logic_vector'("00000000000000000000000000000000");
  subexp17 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((Std_Logic_Vector'(A_ToStdLogicVector(NOT length1(31)) & length1(30 DOWNTO 0))>Std_Logic_Vector'(A_ToStdLogicVector(NOT signal0(31)) & signal0(30 DOWNTO 0))))));
  signal1 <= A_REP(std_logic'('0'), 16) & indexA2;
  signal2 <= std_logic_vector'("00000000000000000000010000000000");
  subexp18 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((Std_Logic_Vector'(A_ToStdLogicVector(NOT signal1(31)) & signal1(30 DOWNTO 0))<Std_Logic_Vector'(A_ToStdLogicVector(NOT signal2(31)) & signal2(30 DOWNTO 0))))));
  subexp19 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((((subexp17 AND subexp18)) = std_logic_vector'("00000000000000000000000000000000")))));
  -- e_assignment on clock 1 for ../fir_hw.c:
  --{
  control_output_break1 <= subexp19;
  -- e_assignment on clock 1 for ../fir_hw.c:
  --{
  if2 <= std_logic_vector'("00000000000000000000000000000001");
  indexA3 <= A_WE_StdLogicVector(((first_time_at_clock_0_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), indexA_init1, indexA2);
  input_data3 <= A_WE_StdLogicVector(((first_time_at_clock_0_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), input_data_init1, input_data2);
  length2 <= A_WE_StdLogicVector(((first_time_at_clock_0_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), length_init1, length1);
  subexp20 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(control_output_break1) AND or_reduce(if2))));
  --the_accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_module0, which is an e_instance
  the_accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_module0 : accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_module0
    port map(
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2 => accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address2,
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0 => accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_read0,
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address1 => accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_address1,
      accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_input_data1_read0_waitrequest_n0,
      advance_to_state_do_0 => advance_to_state_do_0,
      clk => clk,
      enable_state_do_0 => enable_state_do_0,
      reset_n => reset_n
    );


  dataH4 <= dataH3;
  dataI4 <= dataI3;
  subexp21 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic(((((A_REP(std_logic'('0'), 24) & tap_length0) AND std_logic_vector'("00000000000000000000000000000001"))) = std_logic_vector'("00000000000000000000000000000001")))));
  subexp22 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic(((((A_REP(std_logic'('0'), 24) & tap_length0) AND std_logic_vector'("00000000000000000000000000000001"))) = std_logic_vector'("00000000000000000000000000000001")))));
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataA = *input_data++;
  dataA2 <= dereferenced_input_data2;
  dataA4 <= dataA3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataB = dataA;
  dataB2 <= dataA4;
  dataB4 <= dataB3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataC = dataB;
  dataC2 <= dataB4;
  dataC4 <= dataC3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataD = dataC;
  dataD2 <= dataC4;
  dataD4 <= dataD3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataE = dataD;
  dataE2 <= dataD4;
  dataE4 <= dataE3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataF = dataE;
  dataF2 <= dataE4;
  dataF4 <= dataF3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataG = dataF;
  dataG2 <= dataF4;
  dataG4 <= dataG3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataH = dataG;
  dataH2 <= dataG4;
  dataH3 <= A_WE_StdLogicVector(((first_time_at_clock_11_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataH_init1, dataH2);
  dataI3 <= A_WE_StdLogicVector(((first_time_at_clock_11_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataI_init1, dataI2);
  dataJ4 <= dataJ3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataK = dataJ;
  dataK2 <= dataJ4;
  dataK4 <= dataK3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataL = dataK;
  dataL2 <= dataK4;
  dataL4 <= dataL3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataM = dataL;
  dataM2 <= dataL4;
  dataM4 <= dataM3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataN = dataM;
  dataN2 <= dataM4;
  dataN4 <= dataN3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataO = dataN;
  dataO2 <= dataN4;
  dataO4 <= dataO3;
  -- e_assignment on clock 12 for ../fir_hw.c:
  --dataP = dataO;
  dataP2 <= dataO4;
  subexp23 <= A_EXT (((std_logic_vector'("0") & ((A_REP(dataA2(15) , 16) & dataA2))) + (std_logic_vector'("0") & ((A_REP(dataP2(15) , 16) & dataP2)))), 32);
  multiply_assignment0_op_a1 <= subexp23;
  multiply_assignment0_op_b1 <= A_REP(coefA0(15) , 16) & coefA0;
  subexp24 <= A_EXT (((std_logic_vector'("0") & ((A_REP(dataB2(15) , 16) & dataB2))) + (std_logic_vector'("0") & ((A_REP(dataO2(15) , 16) & dataO2)))), 32);
  multiply_assignment1_op_a1 <= subexp24;
  multiply_assignment1_op_b1 <= A_REP(coefB0(15) , 16) & coefB0;
  subexp25 <= A_EXT (((std_logic_vector'("0") & ((A_REP(dataC2(15) , 16) & dataC2))) + (std_logic_vector'("0") & ((A_REP(dataN2(15) , 16) & dataN2)))), 32);
  multiply_assignment2_op_a1 <= subexp25;
  multiply_assignment2_op_b1 <= A_REP(coefC0(15) , 16) & coefC0;
  subexp26 <= A_EXT (((std_logic_vector'("0") & ((A_REP(dataD2(15) , 16) & dataD2))) + (std_logic_vector'("0") & ((A_REP(dataM2(15) , 16) & dataM2)))), 32);
  multiply_assignment3_op_a1 <= subexp26;
  multiply_assignment3_op_b1 <= A_REP(coefD0(15) , 16) & coefD0;
  subexp27 <= A_EXT (((std_logic_vector'("0") & ((A_REP(dataE2(15) , 16) & dataE2))) + (std_logic_vector'("0") & ((A_REP(dataL2(15) , 16) & dataL2)))), 32);
  multiply_assignment4_op_a1 <= subexp27;
  multiply_assignment4_op_b1 <= A_REP(coefE0(15) , 16) & coefE0;
  subexp28 <= A_EXT (((std_logic_vector'("0") & ((A_REP(dataF2(15) , 16) & dataF2))) + (std_logic_vector'("0") & ((A_REP(dataK2(15) , 16) & dataK2)))), 32);
  multiply_assignment5_op_a1 <= subexp28;
  multiply_assignment5_op_b1 <= A_REP(coefF0(15) , 16) & coefF0;
  subexp29 <= A_EXT (((std_logic_vector'("0") & ((A_REP(dataG2(15) , 16) & dataG2))) + (std_logic_vector'("0") & ((A_REP(dataJ2(15) , 16) & dataJ2)))), 32);
  multiply_assignment6_op_a1 <= subexp29;
  multiply_assignment6_op_b1 <= A_REP(coefG0(15) , 16) & coefG0;
  subexp30 <= A_EXT (((std_logic_vector'("0") & ((A_REP(dataH2(15) , 16) & dataH2))) + (std_logic_vector'("0") & ((A_REP(dataI2(15) , 16) & dataI2)))), 32);
  multiply_assignment7_op_a1 <= subexp30;
  multiply_assignment7_op_b1 <= A_REP(coefH0(15) , 16) & coefH0;
  multiply_assignment0_op_a2 <= multiply_assignment0_op_a1;
  multiply_assignment0_op_b2 <= multiply_assignment0_op_b1;
  multiply_assignment5_op_a2 <= multiply_assignment5_op_a1;
  multiply_assignment5_op_b2 <= multiply_assignment5_op_b1;
  multiply_assignment6_op_a2 <= multiply_assignment6_op_a1;
  multiply_assignment6_op_b2 <= multiply_assignment6_op_b1;
  multiply_assignment7_op_a2 <= multiply_assignment7_op_a1;
  multiply_assignment7_op_b2 <= multiply_assignment7_op_b1;
  multiply_assignment1_op_a2 <= multiply_assignment1_op_a1;
  multiply_assignment1_op_b2 <= multiply_assignment1_op_b1;
  multiply_assignment2_op_a2 <= multiply_assignment2_op_a1;
  multiply_assignment2_op_b2 <= multiply_assignment2_op_b1;
  multiply_assignment3_op_a2 <= multiply_assignment3_op_a1;
  multiply_assignment3_op_b2 <= multiply_assignment3_op_b1;
  multiply_assignment4_op_a2 <= multiply_assignment4_op_a1;
  multiply_assignment4_op_b2 <= multiply_assignment4_op_b1;
  dataA3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataA_init1, dataA5);
  dataB3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataB_init1, dataB5);
  dataC3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataC_init1, dataC5);
  dataD3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataD_init1, dataD5);
  dataE3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataE_init1, dataE5);
  dataF3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataF_init1, dataF5);
  dataG3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataG_init1, dataG5);
  dataJ3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataJ_init1, dataJ5);
  dataK3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataK_init1, dataK5);
  dataL3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataL_init1, dataL5);
  dataM3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataM_init1, dataM5);
  dataN3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataN_init1, dataN5);
  dataO3 <= A_WE_StdLogicVector(((first_time_at_clock_12_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dataO_init1, dataO5);
  -- e_assignment on clock 14 for ../fir_hw.c:
  --termA = (dataA + dataP) * coefA;
  termA1 <= multiply1;
  -- e_assignment on clock 14 for ../fir_hw.c:
  --termB = (dataB + dataO) * coefB;
  termB1 <= multiply3;
  -- e_assignment on clock 14 for ../fir_hw.c:
  --termC = (dataC + dataN) * coefC;
  termC1 <= multiply5;
  -- e_assignment on clock 14 for ../fir_hw.c:
  --termD = (dataD + dataM) * coefD;
  termD1 <= multiply7;
  -- e_assignment on clock 14 for ../fir_hw.c:
  --termE = (dataE + dataL) * coefE;
  termE1 <= multiply9;
  -- e_assignment on clock 14 for ../fir_hw.c:
  --termF = (dataF + dataK) * coefF;
  termF1 <= multiply11;
  -- e_assignment on clock 14 for ../fir_hw.c:
  --termG = (dataG + dataJ) * coefG;
  termG1 <= multiply13;
  -- e_assignment on clock 14 for ../fir_hw.c:
  --termH = (dataH + dataI) * coefH;
  termH1 <= multiply15;
  subexp31 <= A_EXT (((std_logic_vector'("0") & (termA1)) + (std_logic_vector'("0") & (termB1))), 32);
  subexp32 <= A_EXT (((std_logic_vector'("0") & (termC1)) + (std_logic_vector'("0") & (termD1))), 32);
  subexp33 <= A_EXT (((std_logic_vector'("0") & (subexp31)) + (std_logic_vector'("0") & (subexp32))), 32);
  subexp34 <= A_EXT (((std_logic_vector'("0") & (termE1)) + (std_logic_vector'("0") & (termF1))), 32);
  subexp35 <= A_EXT (((std_logic_vector'("0") & (termG1)) + (std_logic_vector'("0") & (termH1))), 32);
  subexp36 <= A_EXT (((std_logic_vector'("0") & (subexp34)) + (std_logic_vector'("0") & (subexp35))), 32);
  subexp37 <= A_EXT (((std_logic_vector'("0") & (adderA1)) + (std_logic_vector'("0") & (adderB1))), 32);
  signal3 <= A_REP(std_logic'('0'), 16) & indexA20;
  subexp38 <= A_EXT (((std_logic_vector'("0") & (output_buffer0)) + (std_logic_vector'("0") & (Std_Logic_Vector'(signal3(29 DOWNTO 0) & std_logic_vector'("00"))))), 32);
  -- e_assignment on clock 16 for ../fir_hw.c:
  --output_buffer[indexA] = adderA + adderB;
  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address1 <= subexp38;
  -- e_assignment on clock 16 for ../fir_hw.c:
  --{
  continue1 <= std_logic_vector'("00000000000000000000000000000000");
  subexp39 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return0))));
  subexp40 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(continue1))));
  subexp41 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(break17))));
  subexp42 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp40) AND or_reduce(subexp41))));
  subexp43 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(if17) AND or_reduce(subexp42))));
  subexp44 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp39) AND or_reduce(subexp43))));
  -- e_assignment on clock 16 for ../fir_hw.c:
  --output_buffer[indexA] = adderA + adderB;
  go_bit_control_output7 <= subexp44;
  --the_accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_module0, which is an e_instance
  the_accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_module0 : accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_module0
    port map(
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address2,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_write0,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_writedata0,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address1 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_address1,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexA_p2_write0_waitrequest_n0,
      advance_to_state_do_0 => advance_to_state_do_0,
      clk => clk,
      dereferenced_output_buffer_indexA_p3 => dereferenced_output_buffer_indexA_p3,
      enable_state_do_0 => enable_state_do_0,
      go_bit_control_output7 => go_bit_control_output7,
      reset_n => reset_n
    );


  break34 <= A_WE_StdLogicVector(((first_time_at_clock_17_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), std_logic_vector'("00000000000000000000000000000000"), break33);
  --c_do_block longest path 1
  --due to indexA
  --starts at (enable_state_do_2[1] & advance_to_state_do_2[1])
  --../fir_hw.c:
  --{
  process (clk)
  begin
    if clk'event and clk = '1' then
      if std_logic'((enable_state_do_0(0) AND advance_to_state_do_0(0))) = '1' then 
        first_time_at_clock_0_state_do_1 <= std_logic_vector'("00000000000000000000000000000001");
        first_time_at_clock_11_state_do_1 <= std_logic_vector'("00000000000000000000000000000001");
        first_time_at_clock_12_state_do_1 <= std_logic_vector'("00000000000000000000000000000001");
        first_time_at_clock_17_state_do_1 <= std_logic_vector'("00000000000000000000000000000001");
        break2 <= std_logic_vector'("00000000000000000000000000000000");
      end if;
      if std_logic'((enable_state_do_0(1) AND advance_to_state_do_0(1))) = '1' then 
        first_time_at_clock_0_state_do_1 <= std_logic_vector'("00000000000000000000000000000000");
        indexA2 <= subexp14;
        indexA5 <= indexA4;
        input_data2 <= subexp15;
        input_data5 <= input_data4;
        input_data17 <= input_data4;
        length1 <= subexp16;
      end if;
      if std_logic'((enable_state_do_0(2) AND advance_to_state_do_0(2))) = '1' then 
        -- e_assignment on clock 1 for ../fir_hw.c:
        --{
        break2 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((or_reduce((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((or_reduce(subexp20) OR or_reduce(break1))))))) OR or_reduce(return0))))))) OR or_reduce(return0))));
        break3 <= break1;
        if3 <= if2;
        indexA6 <= indexA5;
        indexA21 <= indexA4;
        input_data6 <= input_data5;
        input_data18 <= input_data4;
        length4 <= length3;
      end if;
      if std_logic'((enable_state_do_0(3) AND advance_to_state_do_0(3))) = '1' then 
        break4 <= break3;
        break18 <= break2;
        if4 <= if3;
        indexA7 <= indexA6;
        input_data7 <= input_data6;
      end if;
      if std_logic'((enable_state_do_0(4) AND advance_to_state_do_0(4))) = '1' then 
        break5 <= break4;
        break19 <= break18;
        if5 <= if4;
        indexA8 <= indexA7;
        input_data8 <= input_data7;
      end if;
      if std_logic'((enable_state_do_0(5) AND advance_to_state_do_0(5))) = '1' then 
        break6 <= break5;
        break20 <= break19;
        if6 <= if5;
        indexA9 <= indexA8;
        input_data9 <= input_data8;
      end if;
      if std_logic'((enable_state_do_0(6) AND advance_to_state_do_0(6))) = '1' then 
        break7 <= break6;
        break21 <= break20;
        if7 <= if6;
        indexA10 <= indexA9;
        input_data10 <= input_data9;
      end if;
      if std_logic'((enable_state_do_0(7) AND advance_to_state_do_0(7))) = '1' then 
        break8 <= break7;
        break22 <= break21;
        if8 <= if7;
        indexA11 <= indexA10;
        input_data11 <= input_data10;
      end if;
      if std_logic'((enable_state_do_0(8) AND advance_to_state_do_0(8))) = '1' then 
        break9 <= break8;
        break23 <= break22;
        if9 <= if8;
        indexA12 <= indexA11;
        input_data12 <= input_data11;
      end if;
      if std_logic'((enable_state_do_0(9) AND advance_to_state_do_0(9))) = '1' then 
        break10 <= break9;
        break24 <= break23;
        if10 <= if9;
        indexA13 <= indexA12;
        input_data13 <= input_data12;
      end if;
      if std_logic'((enable_state_do_0(10) AND advance_to_state_do_0(10))) = '1' then 
        break11 <= break10;
        break25 <= break24;
        if11 <= if10;
        indexA14 <= indexA13;
        input_data14 <= input_data13;
      end if;
      if std_logic'((enable_state_do_0(11) AND advance_to_state_do_0(11))) = '1' then 
        break12 <= break11;
        break26 <= break25;
        if12 <= if11;
        indexA15 <= indexA14;
        input_data15 <= input_data14;
      end if;
      if std_logic'((enable_state_do_0(12) AND advance_to_state_do_0(12))) = '1' then 
        dereferenced_input_data2 <= accelerator_FIR_FIR_HW_master_resource1_fifo_out_aligned0;
        break13 <= break12;
        break27 <= break26;
        -- e_assignment on clock 11 for ../fir_hw.c:
        --dataI = ((tap_length & 0x1) == 0x1)? 0 : dataH;
        dataI2 <= A_EXT (A_WE_StdLogicVector(((subexp21) /= std_logic_vector'("00000000000000000000000000000000")), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000") & (dataH4))), 16);
        -- e_assignment on clock 11 for ../fir_hw.c:
        --dataJ = ((tap_length & 0x1) == 0x1)? dataH : dataI;
        dataJ2 <= A_WE_StdLogicVector(((subexp22) /= std_logic_vector'("00000000000000000000000000000000")), dataH4, dataI4);
        first_time_at_clock_11_state_do_1 <= std_logic_vector'("00000000000000000000000000000000");
        if13 <= if12;
        indexA16 <= indexA15;
        input_data16 <= input_data15;
      end if;
      if std_logic'((enable_state_do_0(13) AND advance_to_state_do_0(13))) = '1' then 
        break14 <= break13;
        break28 <= break27;
        dataA5 <= dataA2;
        dataB5 <= dataB2;
        dataC5 <= dataC2;
        dataD5 <= dataD2;
        dataE5 <= dataE2;
        dataF5 <= dataF2;
        dataG5 <= dataG2;
        dataH5 <= dataH4;
        dataJ5 <= dataJ2;
        dataK5 <= dataK2;
        dataL5 <= dataL2;
        dataM5 <= dataM2;
        dataN5 <= dataN2;
        dataO5 <= dataO2;
        dataP3 <= dataP2;
        first_time_at_clock_12_state_do_1 <= std_logic_vector'("00000000000000000000000000000000");
        if14 <= if13;
        indexA17 <= indexA16;
      end if;
      if std_logic'((enable_state_do_0(14) AND advance_to_state_do_0(14))) = '1' then 
        multiply1 <= multiply_assignment0_prod0 (31 DOWNTO 0);
        multiply11 <= multiply_assignment5_prod0 (31 DOWNTO 0);
        multiply13 <= multiply_assignment6_prod0 (31 DOWNTO 0);
        multiply15 <= multiply_assignment7_prod0 (31 DOWNTO 0);
        multiply3 <= multiply_assignment1_prod0 (31 DOWNTO 0);
        multiply5 <= multiply_assignment2_prod0 (31 DOWNTO 0);
        multiply7 <= multiply_assignment3_prod0 (31 DOWNTO 0);
        multiply9 <= multiply_assignment4_prod0 (31 DOWNTO 0);
        break15 <= break14;
        break29 <= break28;
        if15 <= if14;
        indexA18 <= indexA17;
      end if;
      if std_logic'((enable_state_do_0(15) AND advance_to_state_do_0(15))) = '1' then 
        -- e_assignment on clock 14 for ../fir_hw.c:
        --adderA = (termA + termB) + (termC + termD);
        adderA1 <= subexp33;
        -- e_assignment on clock 14 for ../fir_hw.c:
        --adderB = (termE + termF) + (termG + termH);
        adderB1 <= subexp36;
        break16 <= break15;
        break30 <= break29;
        if16 <= if15;
        indexA19 <= indexA18;
      end if;
      if std_logic'((enable_state_do_0(16) AND advance_to_state_do_0(16))) = '1' then 
        break17 <= break16;
        break31 <= break30;
        -- e_assignment on clock 15 for ../fir_hw.c:
        --output_buffer[indexA] = adderA + adderB;
        dereferenced_output_buffer_indexA_p3 <= subexp37;
        if17 <= if16;
        indexA20 <= indexA19;
      end if;
      if std_logic'((enable_state_do_0(17) AND advance_to_state_do_0(17))) = '1' then 
        break32 <= break31;
      end if;
      if std_logic'((enable_state_do_0(18) AND advance_to_state_do_0(18))) = '1' then 
        break33 <= break32;
        first_time_at_clock_17_state_do_1 <= std_logic_vector'("00000000000000000000000000000000");
      end if;
    end if;

  end process;

  signal4 <= std_logic_vector'("00000000000000000000000000000000");
  subexp45 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((Std_Logic_Vector'(A_ToStdLogicVector(NOT length5(31)) & length5(30 DOWNTO 0))>Std_Logic_Vector'(A_ToStdLogicVector(NOT signal4(31)) & signal4(30 DOWNTO 0))))));
  subexp46 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((subexp45 = std_logic_vector'("00000000000000000000000000000000")))));
  -- e_assignment on clock 2 for ../fir_hw.c:
  --{
  control_output_break5 <= subexp46;
  -- e_assignment on clock 2 for ../fir_hw.c:
  --indexB = 0;
  indexB1 <= std_logic_vector'("0000000000000000");
  output_data14 <= output_data13;
  subexp47 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(control_output_break5) AND or_reduce(if1))));
  --c_do_block
  accelerator_FIR_FIR_HW_FIR_HW0_the_state_machine_do_2 : accelerator_FIR_FIR_HW_FIR_HW0_state_machine_do_2
    port map(
      advance_to_state_do_1 => advance_to_state_do_1,
      enable_state_do_1 => enable_state_do_1,
      inhibit_from_c_do_block2 => inhibit_from_c_do_block2,
      state_do_1 => state_do_1,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0,
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 => accelerator_FIR_FIR_HW_master_resource2_fifo_empty0,
      advance_to_state_do_2 => advance_to_state_do_2,
      break36 => break36,
      break48 => break48,
      clk => clk,
      enable_state_do_2 => enable_state_do_2,
      go_bit_control_output9 => go_bit_control_output9,
      reset_n => reset_n
    );


  indexB_init1 <= indexB1;
  output_data_init1 <= output_data14;
  --the_accelerator_FIR_FIR_HW_master_resource3, which is an e_instance
  the_accelerator_FIR_FIR_HW_master_resource3 : accelerator_FIR_FIR_HW_master_resource3
    port map(
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource3_address0 => internal_accelerator_FIR_FIR_HW_master_resource3_address1,
      accelerator_FIR_FIR_HW_master_resource3_byteenable0 => internal_accelerator_FIR_FIR_HW_master_resource3_byteenable1,
      accelerator_FIR_FIR_HW_master_resource3_write0 => internal_accelerator_FIR_FIR_HW_master_resource3_write1,
      accelerator_FIR_FIR_HW_master_resource3_writedata0 => internal_accelerator_FIR_FIR_HW_master_resource3_writedata1,
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2,
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0,
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0,
      accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0 => accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0,
      advance_to_state_do_1 => advance_to_state_do_1,
      clk => clk,
      enable_state_do_1 => enable_state_do_1,
      go_bit_control_output19 => go_bit_control_output19,
      reset_n => reset_n
    );


  --the_accelerator_FIR_FIR_HW_master_resource2, which is an e_instance
  the_accelerator_FIR_FIR_HW_master_resource2 : accelerator_FIR_FIR_HW_master_resource2
    port map(
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource2_address0 => internal_accelerator_FIR_FIR_HW_master_resource2_address1,
      accelerator_FIR_FIR_HW_master_resource2_fifo_empty0 => accelerator_FIR_FIR_HW_master_resource2_fifo_empty0,
      accelerator_FIR_FIR_HW_master_resource2_fifo_out_aligned0 => accelerator_FIR_FIR_HW_master_resource2_fifo_out_aligned0,
      accelerator_FIR_FIR_HW_master_resource2_flush0 => internal_accelerator_FIR_FIR_HW_master_resource2_flush1,
      accelerator_FIR_FIR_HW_master_resource2_read0 => internal_accelerator_FIR_FIR_HW_master_resource2_read1,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0,
      accelerator_FIR_FIR_HW_master_resource2_readdata0 => accelerator_FIR_FIR_HW_master_resource2_readdata0,
      accelerator_FIR_FIR_HW_master_resource2_readdatavalid0 => accelerator_FIR_FIR_HW_master_resource2_readdatavalid0,
      accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0 => accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0,
      advance_to_state_do_1 => advance_to_state_do_1,
      clk => clk,
      enable_state_do_1 => enable_state_do_1,
      reset_n => reset_n
    );


  indexB4 <= indexB3;
  output_data4 <= output_data3;
  subexp48 <= A_EXT (((std_logic_vector'("00000000000000000") & (indexB4)) + std_logic_vector'("000000000000000000000000000000001")), 16);
  subexp49 <= A_EXT (((std_logic_vector'("0") & (output_data4)) + std_logic_vector'("000000000000000000000000000000010")), 32);
  signal5 <= A_REP(std_logic'('0'), 16) & indexB5;
  subexp50 <= A_EXT (((std_logic_vector'("0") & (output_buffer0)) + (std_logic_vector'("0") & (Std_Logic_Vector'(signal5(29 DOWNTO 0) & std_logic_vector'("00"))))), 32);
  -- e_assignment on clock 1 for ../fir_hw.c:
  --*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address1 <= subexp50;
  signal6 <= A_REP(std_logic'('0'), 16) & indexB5;
  subexp51 <= A_EXT (((std_logic_vector'("0") & (output_buffer0)) + (std_logic_vector'("0") & (Std_Logic_Vector'(signal6(29 DOWNTO 0) & std_logic_vector'("00"))))), 32);
  -- e_assignment on clock 1 for ../fir_hw.c:
  --*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p3_read0_address1 <= subexp51;
  signal7 <= A_REP(std_logic'('0'), 16) & indexB5;
  subexp52 <= A_EXT (((std_logic_vector'("0") & (output_buffer0)) + (std_logic_vector'("0") & (Std_Logic_Vector'(signal7(29 DOWNTO 0) & std_logic_vector'("00"))))), 32);
  -- e_assignment on clock 1 for ../fir_hw.c:
  --*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p4_read0_address1 <= subexp52;
  signal8 <= A_REP(std_logic'('0'), 16) & indexB5;
  subexp53 <= A_EXT (((std_logic_vector'("0") & (output_buffer0)) + (std_logic_vector'("0") & (Std_Logic_Vector'(signal8(29 DOWNTO 0) & std_logic_vector'("00"))))), 32);
  -- e_assignment on clock 1 for ../fir_hw.c:
  --*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
  accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p5_read0_address1 <= subexp53;
  -- e_assignment on clock 1 for ../fir_hw.c:
  --{
  break35 <= std_logic_vector'("00000000000000000000000000000000");
  signal9 <= A_REP(std_logic'('0'), 16) & indexB2;
  signal10 <= A_REP(std_logic'('0'), 16) & indexA22;
  subexp54 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((Std_Logic_Vector'(A_ToStdLogicVector(NOT signal9(31)) & signal9(30 DOWNTO 0))<Std_Logic_Vector'(A_ToStdLogicVector(NOT signal10(31)) & signal10(30 DOWNTO 0))))));
  subexp55 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((subexp54 = std_logic_vector'("00000000000000000000000000000000")))));
  -- e_assignment on clock 1 for ../fir_hw.c:
  --{
  control_output_break3 <= subexp55;
  -- e_assignment on clock 1 for ../fir_hw.c:
  --{
  if18 <= std_logic_vector'("00000000000000000000000000000001");
  indexB3 <= A_WE_StdLogicVector(((first_time_at_clock_0_state_do_4) /= std_logic_vector'("00000000000000000000000000000000")), indexB_init1, indexB2);
  output_data3 <= A_WE_StdLogicVector(((first_time_at_clock_0_state_do_4) /= std_logic_vector'("00000000000000000000000000000000")), output_data_init1, output_data2);
  subexp56 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(control_output_break3) AND or_reduce(if18))));
  --the_accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_module0, which is an e_instance
  the_accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_module0 : accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_module0
    port map(
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address2,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_read0,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address1 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_address1,
      accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_buffer_indexB_p2_read0_waitrequest_n0,
      advance_to_state_do_1 => advance_to_state_do_1,
      clk => clk,
      enable_state_do_1 => enable_state_do_1,
      reset_n => reset_n
    );


  --equivalent data pointer
  dereferenced_output_buffer_indexB_p4 <= dereferenced_output_buffer_indexB_p3;
  --equivalent data pointer
  dereferenced_output_buffer_indexB_p5 <= dereferenced_output_buffer_indexB_p3;
  --equivalent data pointer
  dereferenced_output_buffer_indexB_p6 <= dereferenced_output_buffer_indexB_p3;
  subexp57 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic(((A_REP(std_logic'('0'), 24) & divide_order0) = std_logic_vector'("00000000000000000000000000001101")))));
  subexp58 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic(((A_REP(std_logic'('0'), 24) & divide_order0) = std_logic_vector'("00000000000000000000000000001110")))));
  subexp59 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic(((A_REP(std_logic'('0'), 24) & divide_order0) = std_logic_vector'("00000000000000000000000000001111")))));
  -- e_assignment on clock 6 for ../fir_hw.c:
  --*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
  accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address1 <= output_data10;
  -- e_assignment on clock 6 for ../fir_hw.c:
  --{
  continue2 <= std_logic_vector'("00000000000000000000000000000000");
  subexp60 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return0))));
  subexp61 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(continue2))));
  subexp62 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(break41))));
  subexp63 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp61) AND or_reduce(subexp62))));
  subexp64 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(if23) AND or_reduce(subexp63))));
  subexp65 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp60) AND or_reduce(subexp64))));
  -- e_assignment on clock 6 for ../fir_hw.c:
  --*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
  go_bit_control_output19 <= subexp65;
  --the_accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_module0, which is an e_instance
  the_accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_module0 : accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_module0
    port map(
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address2,
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_write0,
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_writedata0,
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address1 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_address1,
      accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0 => accelerator_FIR_FIR_HW_dereferenced_output_data1_write0_waitrequest_n0,
      advance_to_state_do_1 => advance_to_state_do_1,
      clk => clk,
      dereferenced_output_data2 => dereferenced_output_data2,
      enable_state_do_1 => enable_state_do_1,
      go_bit_control_output19 => go_bit_control_output19,
      reset_n => reset_n
    );


  break48 <= A_WE_StdLogicVector(((first_time_at_clock_7_state_do_2) /= std_logic_vector'("00000000000000000000000000000000")), std_logic_vector'("00000000000000000000000000000000"), break47);
  --c_do_block longest path 1
  --due to indexB
  --starts at (enable_state_do_2[2] & advance_to_state_do_2[2])
  --../fir_hw.c:
  --{
  process (clk)
  begin
    if clk'event and clk = '1' then
      if std_logic'((enable_state_do_1(0) AND advance_to_state_do_1(0))) = '1' then 
        first_time_at_clock_0_state_do_4 <= std_logic_vector'("00000000000000000000000000000001");
        first_time_at_clock_7_state_do_2 <= std_logic_vector'("00000000000000000000000000000001");
        break36 <= std_logic_vector'("00000000000000000000000000000000");
      end if;
      if std_logic'((enable_state_do_1(1) AND advance_to_state_do_1(1))) = '1' then 
        first_time_at_clock_0_state_do_4 <= std_logic_vector'("00000000000000000000000000000000");
        indexB2 <= subexp48;
        indexB5 <= indexB4;
        output_data2 <= subexp49;
        output_data5 <= output_data4;
      end if;
      if std_logic'((enable_state_do_1(2) AND advance_to_state_do_1(2))) = '1' then 
        -- e_assignment on clock 1 for ../fir_hw.c:
        --{
        break36 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((or_reduce((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((or_reduce(subexp56) OR or_reduce(break35))))))) OR or_reduce(return0))))))) OR or_reduce(return0))));
        break37 <= break35;
        if19 <= if18;
        indexB6 <= indexB5;
        indexB10 <= indexB4;
        output_data6 <= output_data5;
        output_data11 <= output_data4;
      end if;
      if std_logic'((enable_state_do_1(3) AND advance_to_state_do_1(3))) = '1' then 
        break38 <= break37;
        break42 <= break36;
        if20 <= if19;
        indexB7 <= indexB6;
        output_data7 <= output_data6;
      end if;
      if std_logic'((enable_state_do_1(4) AND advance_to_state_do_1(4))) = '1' then 
        break39 <= break38;
        break43 <= break42;
        if21 <= if20;
        indexB8 <= indexB7;
        output_data8 <= output_data7;
      end if;
      if std_logic'((enable_state_do_1(5) AND advance_to_state_do_1(5))) = '1' then 
        dereferenced_output_buffer_indexB_p3 <= accelerator_FIR_FIR_HW_master_resource2_fifo_out_aligned0;
        break40 <= break39;
        break44 <= break43;
        if22 <= if21;
        indexB9 <= indexB8;
        output_data9 <= output_data8;
      end if;
      if std_logic'((enable_state_do_1(6) AND advance_to_state_do_1(6))) = '1' then 
        break41 <= break40;
        break45 <= break44;
        -- e_assignment on clock 5 for ../fir_hw.c:
        --*output_data++ = (divide_order == 13)? (short)(output_buffer[indexB] >> 13):
        dereferenced_output_data2 <= A_EXT (A_WE_StdLogicVector(((subexp57) /= std_logic_vector'("00000000000000000000000000000000")), (A_REP(dereferenced_output_buffer_indexB_p3(31) , 13) & dereferenced_output_buffer_indexB_p3(31 DOWNTO 13)), (A_WE_StdLogicVector(((subexp58) /= std_logic_vector'("00000000000000000000000000000000")), (A_REP(dereferenced_output_buffer_indexB_p4(31) , 14) & dereferenced_output_buffer_indexB_p4(31 DOWNTO 14)), (A_WE_StdLogicVector(((subexp59) /= std_logic_vector'("00000000000000000000000000000000")), (A_REP(dereferenced_output_buffer_indexB_p5(31) , 15) & dereferenced_output_buffer_indexB_p5(31 DOWNTO 15)), (A_REP(dereferenced_output_buffer_indexB_p6(31) , 16) & dereferenced_output_buffer_indexB_p6(31 DOWNTO 16))))))), 16);
        if23 <= if22;
        output_data10 <= output_data9;
      end if;
      if std_logic'((enable_state_do_1(7) AND advance_to_state_do_1(7))) = '1' then 
        break46 <= break45;
      end if;
      if std_logic'((enable_state_do_1(8) AND advance_to_state_do_1(8))) = '1' then 
        break47 <= break46;
        first_time_at_clock_7_state_do_2 <= std_logic_vector'("00000000000000000000000000000000");
      end if;
    end if;

  end process;

  break50 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), std_logic_vector'("00000000000000000000000000000000"), break49);
  dataA7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataA_init3, dataA6);
  dataB7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataB_init3, dataB6);
  dataC7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataC_init3, dataC6);
  dataD7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataD_init3, dataD6);
  dataE7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataE_init3, dataE6);
  dataF7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataF_init3, dataF6);
  dataG7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataG_init3, dataG6);
  dataH7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataH_init3, dataH6);
  dataI6 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataI_init3, dataI5);
  dataJ7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataJ_init3, dataJ6);
  dataK7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataK_init3, dataK6);
  dataL7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataL_init3, dataL6);
  dataM7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataM_init3, dataM6);
  dataN7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataN_init3, dataN6);
  dataO7 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), dataO_init3, dataO6);
  input_data20 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), input_data_init3, input_data19);
  length6 <= A_WE_StdLogicVector(((first_time_at_clock_2_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), length_init3, length5);
  output_data13 <= A_WE_StdLogicVector(((first_time_at_clock_3_state_do_3) /= std_logic_vector'("00000000000000000000000000000000")), output_data_init3, output_data12);
  --c_do_block longest path 2
  --due to Loop Condition
  --starts at (enable_FIR_HW_state0[1] & advance_to_FIR_HW_state0[1])
  --../fir_hw.c:
  --{
  process (clk)
  begin
    if clk'event and clk = '1' then
      if std_logic'((enable_state_do_2(0) AND advance_to_state_do_2(0))) = '1' then 
        first_time_at_clock_2_state_do_3 <= std_logic_vector'("00000000000000000000000000000001");
        first_time_at_clock_3_state_do_3 <= std_logic_vector'("00000000000000000000000000000001");
        break49 <= std_logic_vector'("00000000000000000000000000000000");
      end if;
      if std_logic'((enable_state_do_2(2) AND advance_to_state_do_2(2))) = '1' then 
        adderA2 <= adderA1;
        adderB2 <= adderB1;
        dataA6 <= dataA4;
        dataB6 <= dataB4;
        dataC6 <= dataC4;
        dataD6 <= dataD4;
        dataE6 <= dataE4;
        dataF6 <= dataF4;
        dataG6 <= dataG4;
        dataH6 <= dataH5;
        dataI5 <= dataI4;
        dataJ6 <= dataJ4;
        dataK6 <= dataK4;
        dataL6 <= dataL4;
        dataM6 <= dataM4;
        dataN6 <= dataN4;
        dataO6 <= dataO4;
        dataP4 <= dataP3;
        indexA22 <= indexA21;
        input_data19 <= input_data18;
        length5 <= length4;
        termA2 <= termA1;
        termB2 <= termB1;
        termC2 <= termC1;
        termD2 <= termD1;
        termE2 <= termE1;
        termF2 <= termF1;
        termG2 <= termG1;
        termH2 <= termH1;
      end if;
      if std_logic'((enable_state_do_2(3) AND advance_to_state_do_2(3))) = '1' then 
        -- e_assignment on clock 2 for ../fir_hw.c:
        --{
        break49 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((or_reduce((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((or_reduce(subexp47) OR or_reduce(break0))))))) OR or_reduce(return0))))))) OR or_reduce(return0))));
        first_time_at_clock_2_state_do_3 <= std_logic_vector'("00000000000000000000000000000000");
        indexB11 <= indexB10;
        output_data12 <= output_data11;
      end if;
      if std_logic'((enable_state_do_2(4) AND advance_to_state_do_2(4))) = '1' then 
        first_time_at_clock_3_state_do_3 <= std_logic_vector'("00000000000000000000000000000000");
      end if;
    end if;

  end process;

  --c_subroutine_block process, accelerator_FIR_FIR_HW_FIR_HW0
  process (clk)
  begin
    if clk'event and clk = '1' then
      if std_logic'((enable_FIR_HW_state0(2) AND advance_to_FIR_HW_state0(2))) = '1' then 
        adderA3 <= adderA2;
        adderB3 <= adderB2;
        dataA9 <= dataA8;
        dataB9 <= dataB8;
        dataC9 <= dataC8;
        dataD9 <= dataD8;
        dataE9 <= dataE8;
        dataF9 <= dataF8;
        dataG9 <= dataG8;
        dataH9 <= dataH8;
        dataI8 <= dataI7;
        dataJ9 <= dataJ8;
        dataK9 <= dataK8;
        dataL9 <= dataL8;
        dataM9 <= dataM8;
        dataN9 <= dataN8;
        dataO9 <= dataO8;
        dataP5 <= dataP4;
        indexA23 <= indexA22;
        indexB12 <= indexB11;
        input_data22 <= input_data21;
        length8 <= length7;
        output_data15 <= output_data14;
        termA3 <= termA2;
        termB3 <= termB2;
        termC3 <= termC2;
        termD3 <= termD2;
        termE3 <= termE2;
        termF3 <= termF2;
        termG3 <= termG2;
        termH3 <= termH2;
      end if;
    end if;

  end process;

  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource0_address0 <= internal_accelerator_FIR_FIR_HW_master_resource0_address1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource0_byteenable0 <= internal_accelerator_FIR_FIR_HW_master_resource0_byteenable1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource0_write0 <= internal_accelerator_FIR_FIR_HW_master_resource0_write1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource0_writedata0 <= internal_accelerator_FIR_FIR_HW_master_resource0_writedata1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource1_address0 <= internal_accelerator_FIR_FIR_HW_master_resource1_address1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource1_flush0 <= internal_accelerator_FIR_FIR_HW_master_resource1_flush1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource1_read0 <= internal_accelerator_FIR_FIR_HW_master_resource1_read1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource2_address0 <= internal_accelerator_FIR_FIR_HW_master_resource2_address1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource2_flush0 <= internal_accelerator_FIR_FIR_HW_master_resource2_flush1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource2_read0 <= internal_accelerator_FIR_FIR_HW_master_resource2_read1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource3_address0 <= internal_accelerator_FIR_FIR_HW_master_resource3_address1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource3_byteenable0 <= internal_accelerator_FIR_FIR_HW_master_resource3_byteenable1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource3_write0 <= internal_accelerator_FIR_FIR_HW_master_resource3_write1;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource3_writedata0 <= internal_accelerator_FIR_FIR_HW_master_resource3_writedata1;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library altera_mf;
use altera_mf.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library lpm;
use lpm.all;

entity accelerator_FIR_FIR_HW_cpu_registers0 is 
        port (
              -- inputs:
                 signal FIR_HW0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_address0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_clk : IN STD_LOGIC;
                 signal cpu_reset_n : IN STD_LOGIC;
                 signal cpu_select0 : IN STD_LOGIC;
                 signal cpu_write0 : IN STD_LOGIC;
                 signal cpu_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal slave_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_waitrequest_n0 : IN STD_LOGIC;

              -- outputs:
                 signal cpu_readdata1 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_waitrequest_n0 : OUT STD_LOGIC;
                 signal slave_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_functiondata0 : OUT STD_LOGIC_VECTOR (239 DOWNTO 0);
                 signal slave_read0 : OUT STD_LOGIC
              );
end entity accelerator_FIR_FIR_HW_cpu_registers0;


architecture europa of accelerator_FIR_FIR_HW_cpu_registers0 is
--synthesis read_comments_as_HDL on
--  component c2h_port_byte_refine is
--GENERIC (
--      c2h_param1 : NATURAL;
--        c2h_param2 : NATURAL;
--        c2h_param3 : NATURAL;
--        c2h_param4 : NATURAL
--      );
--    PORT (
--    signal port_d : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
--        signal port_c : IN STD_LOGIC;
--        signal port_a : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
--        signal port_b : IN STD_LOGIC_VECTOR (3 DOWNTO 0)
--      );
--  end component c2h_port_byte_refine;
--synthesis read_comments_as_HDL off
                signal coefA1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefB1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefC1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefD1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefE1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefF1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefG1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal coefH1 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal cpu_address_c2hplus0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal divide_order1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal input_data23 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_slave_read1 :  STD_LOGIC;
                signal length9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal output_data16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal polled_data_ready0 :  STD_LOGIC;
                signal tap_length1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal tmp_cpu_readdata1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);

--synthesis read_comments_as_HDL on
--                signal port_monitor0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);

--synthesis read_comments_as_HDL off

begin

  --cpu interface register for input_data23, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      input_data23(31 DOWNTO 0) <= std_logic_vector'("00000000000000000000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        input_data23(31 DOWNTO 0) <= cpu_writedata0;
      end if;
    end if;

  end process;

  --cpu interface register for length9, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      length9(31 DOWNTO 0) <= std_logic_vector'("00000000000000000000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        length9(31 DOWNTO 0) <= cpu_writedata0;
      end if;
    end if;

  end process;

  --cpu interface register for output_data16, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      output_data16(31 DOWNTO 0) <= std_logic_vector'("00000000000000000000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000011")))))) = '1' then 
        output_data16(31 DOWNTO 0) <= cpu_writedata0;
      end if;
    end if;

  end process;

  --cpu interface register for tap_length1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      tap_length1(7 DOWNTO 0) <= std_logic_vector'("00000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000100")))))) = '1' then 
        tap_length1(7 DOWNTO 0) <= cpu_writedata0 (7 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for coefA1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      coefA1(15 DOWNTO 0) <= std_logic_vector'("0000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000101")))))) = '1' then 
        coefA1(15 DOWNTO 0) <= cpu_writedata0 (15 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for coefB1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      coefB1(15 DOWNTO 0) <= std_logic_vector'("0000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000110")))))) = '1' then 
        coefB1(15 DOWNTO 0) <= cpu_writedata0 (15 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for coefC1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      coefC1(15 DOWNTO 0) <= std_logic_vector'("0000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000111")))))) = '1' then 
        coefC1(15 DOWNTO 0) <= cpu_writedata0 (15 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for coefD1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      coefD1(15 DOWNTO 0) <= std_logic_vector'("0000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000001000")))))) = '1' then 
        coefD1(15 DOWNTO 0) <= cpu_writedata0 (15 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for coefE1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      coefE1(15 DOWNTO 0) <= std_logic_vector'("0000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000001001")))))) = '1' then 
        coefE1(15 DOWNTO 0) <= cpu_writedata0 (15 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for coefF1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      coefF1(15 DOWNTO 0) <= std_logic_vector'("0000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000001010")))))) = '1' then 
        coefF1(15 DOWNTO 0) <= cpu_writedata0 (15 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for coefG1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      coefG1(15 DOWNTO 0) <= std_logic_vector'("0000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000001011")))))) = '1' then 
        coefG1(15 DOWNTO 0) <= cpu_writedata0 (15 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for coefH1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      coefH1(15 DOWNTO 0) <= std_logic_vector'("0000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000001100")))))) = '1' then 
        coefH1(15 DOWNTO 0) <= cpu_writedata0 (15 DOWNTO 0);
      end if;
    end if;

  end process;

  --cpu interface register for divide_order1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      divide_order1(7 DOWNTO 0) <= std_logic_vector'("00000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000001101")))))) = '1' then 
        divide_order1(7 DOWNTO 0) <= cpu_writedata0 (7 DOWNTO 0);
      end if;
    end if;

  end process;

  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      tmp_cpu_readdata1 <= std_logic_vector'("00000000000000000000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'((slave_waitrequest_n0 AND internal_slave_read1)) = '1' then 
        tmp_cpu_readdata1 <= slave_readdata0;
      end if;
    end if;

  end process;

  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      polled_data_ready0 <= std_logic'('0');
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        polled_data_ready0 <= std_logic'('0');
      elsif std_logic'(slave_waitrequest_n0) = '1' then 
        polled_data_ready0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      end if;
    end if;

  end process;

  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      internal_slave_read1 <= std_logic'('0');
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'((((cpu_write0 AND cpu_select0) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000000"))))) AND cpu_writedata0(0))) = '1' then 
        internal_slave_read1 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      elsif std_logic'(slave_waitrequest_n0) = '1' then 
        internal_slave_read1 <= std_logic'('0');
      end if;
    end if;

  end process;

  cpu_readdata1 <= A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000000"))), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(polled_data_ready0))), tmp_cpu_readdata1);
  cpu_waitrequest_n0 <= std_logic'('1');
  slave_address0 <= FIR_HW0;
  slave_functiondata0 <= input_data23 & length9 & output_data16 & tap_length1 & coefA1 & coefB1 & coefC1 & coefD1 & coefE1 & coefF1 & coefG1 & coefH1 & divide_order1;
  --vhdl renameroo for output signals
  slave_read0 <= internal_slave_read1;
--synthesis translate_off
    cpu_address_c2hplus0 <= cpu_address0;
--synthesis translate_on
--synthesis read_comments_as_HDL on
--    port_monitor0 <= std_logic_vector'("0000");
--    the_c2h_port_byte_refine : c2h_port_byte_refine
--      generic map(
--        c2h_param1 => 4,
--        c2h_param2 => 2,
--        c2h_param3 => 2,
--        c2h_param4 => 0
--      )
--      port map(
--                port_a => cpu_address0,
--                port_b => port_monitor0,
--                port_c => reset_n,
--                port_d => cpu_address_c2hplus0
--      );
--
--synthesis read_comments_as_HDL off

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_FIR_FIR_HW is 
        port (
              -- inputs:
                 signal FIR_HW_begin0 : IN STD_LOGIC;
                 signal FIR_HW_read0 : IN STD_LOGIC;
                 signal FIR_HW_select0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_readdata0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource2_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_a0 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_base_address0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_be0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_chipselect0 : IN STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_d0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_write0 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_address0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_clk : IN STD_LOGIC;
                 signal cpu_reset_n : IN STD_LOGIC;
                 signal cpu_select0 : IN STD_LOGIC;
                 signal cpu_write0 : IN STD_LOGIC;
                 signal cpu_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal dummy_master_waitrequest : IN STD_LOGIC;
                 signal dummy_slave_address : IN STD_LOGIC;
                 signal dummy_slave_chipselect : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal slave_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_waitrequest_n0 : IN STD_LOGIC;

              -- outputs:
                 signal FIR_HW_waitrequest_n0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource0_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource0_write0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource1_flush0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource1_read0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource2_flush0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource2_read0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource3_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource3_byteenable0 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_master_resource3_write0 : OUT STD_LOGIC;
                 signal accelerator_FIR_FIR_HW_master_resource3_writedata0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_readdata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_readdata1 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_waitrequest_n0 : OUT STD_LOGIC;
                 signal dummy_master_address : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal dummy_master_write : OUT STD_LOGIC;
                 signal dummy_master_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal dummy_slave_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_read0 : OUT STD_LOGIC
              );
end entity accelerator_FIR_FIR_HW;


architecture europa of accelerator_FIR_FIR_HW is
component accelerator_FIR_FIR_HW_output_buffer0 is 
           port (
                 -- inputs:
                    signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_a0 : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_be0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_d0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_we0 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_output_buffer0;

component accelerator_FIR_FIR_HW_FIR_HW0 is 
           port (
                 -- inputs:
                    signal FIR_HW_begin0 : IN STD_LOGIC;
                    signal FIR_HW_functiondata0 : IN STD_LOGIC_VECTOR (239 DOWNTO 0);
                    signal FIR_HW_read0 : IN STD_LOGIC;
                    signal FIR_HW_select0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_readdata0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource1_readdatavalid0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource2_readdatavalid0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_base_address0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal FIR_HW_waitrequest_n0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource0_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource0_write0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource1_flush0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource1_read0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource2_flush0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource2_read0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource3_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource3_byteenable0 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal accelerator_FIR_FIR_HW_master_resource3_write0 : OUT STD_LOGIC;
                    signal accelerator_FIR_FIR_HW_master_resource3_writedata0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal cpu_readdata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component accelerator_FIR_FIR_HW_FIR_HW0;

component accelerator_FIR_FIR_HW_cpu_registers0 is 
           port (
                 -- inputs:
                    signal FIR_HW0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_address0 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_clk : IN STD_LOGIC;
                    signal cpu_reset_n : IN STD_LOGIC;
                    signal cpu_select0 : IN STD_LOGIC;
                    signal cpu_write0 : IN STD_LOGIC;
                    signal cpu_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal slave_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal slave_waitrequest_n0 : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_readdata1 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_waitrequest_n0 : OUT STD_LOGIC;
                    signal slave_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal slave_functiondata0 : OUT STD_LOGIC_VECTOR (239 DOWNTO 0);
                    signal slave_read0 : OUT STD_LOGIC
                 );
end component accelerator_FIR_FIR_HW_cpu_registers0;

                signal FIR_HW0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal FIR_HW_functiondata0 :  STD_LOGIC_VECTOR (239 DOWNTO 0);
                signal accelerator_FIR_FIR_HW_output_buffer_internal_memory0_we0 :  STD_LOGIC;
                signal dummy_address_sink :  STD_LOGIC;
                signal dummy_chipselect_sink :  STD_LOGIC;
                signal dummy_waitrequest_sink :  STD_LOGIC;
                signal internal_FIR_HW_waitrequest_n0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource0_address0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource0_byteenable0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource0_write0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource0_writedata0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource1_address0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource1_flush0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource1_read0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource2_address0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource2_flush0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource2_read0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource3_address0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource3_byteenable0 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_master_resource3_write0 :  STD_LOGIC;
                signal internal_accelerator_FIR_FIR_HW_master_resource3_writedata0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_cpu_readdata0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_cpu_readdata1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_cpu_waitrequest_n0 :  STD_LOGIC;
                signal internal_slave_address0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_slave_read0 :  STD_LOGIC;
                signal slave_functiondata0 :  STD_LOGIC_VECTOR (239 DOWNTO 0);

begin

  --the_accelerator_FIR_FIR_HW_output_buffer0, which is an e_instance
  the_accelerator_FIR_FIR_HW_output_buffer0 : accelerator_FIR_FIR_HW_output_buffer0
    port map(
      accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0 => internal_accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0,
      accelerator_FIR_FIR_HW_output_buffer_internal_memory0_a0 => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_a0,
      accelerator_FIR_FIR_HW_output_buffer_internal_memory0_be0 => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_be0,
      accelerator_FIR_FIR_HW_output_buffer_internal_memory0_d0 => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_d0,
      accelerator_FIR_FIR_HW_output_buffer_internal_memory0_we0 => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_we0,
      clk => clk
    );


  accelerator_FIR_FIR_HW_output_buffer_internal_memory0_we0 <= accelerator_FIR_FIR_HW_output_buffer_internal_memory0_write0 AND accelerator_FIR_FIR_HW_output_buffer_internal_memory0_chipselect0;
  --accelerator_FIR_FIR_HW_output_buffer_internal_memory0_slave, which is an e_avalon_slave
  --the_accelerator_FIR_FIR_HW_FIR_HW0, which is an e_instance
  the_accelerator_FIR_FIR_HW_FIR_HW0 : accelerator_FIR_FIR_HW_FIR_HW0
    port map(
      FIR_HW_waitrequest_n0 => internal_FIR_HW_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource0_address0 => internal_accelerator_FIR_FIR_HW_master_resource0_address0,
      accelerator_FIR_FIR_HW_master_resource0_byteenable0 => internal_accelerator_FIR_FIR_HW_master_resource0_byteenable0,
      accelerator_FIR_FIR_HW_master_resource0_write0 => internal_accelerator_FIR_FIR_HW_master_resource0_write0,
      accelerator_FIR_FIR_HW_master_resource0_writedata0 => internal_accelerator_FIR_FIR_HW_master_resource0_writedata0,
      accelerator_FIR_FIR_HW_master_resource1_address0 => internal_accelerator_FIR_FIR_HW_master_resource1_address0,
      accelerator_FIR_FIR_HW_master_resource1_flush0 => internal_accelerator_FIR_FIR_HW_master_resource1_flush0,
      accelerator_FIR_FIR_HW_master_resource1_read0 => internal_accelerator_FIR_FIR_HW_master_resource1_read0,
      accelerator_FIR_FIR_HW_master_resource2_address0 => internal_accelerator_FIR_FIR_HW_master_resource2_address0,
      accelerator_FIR_FIR_HW_master_resource2_flush0 => internal_accelerator_FIR_FIR_HW_master_resource2_flush0,
      accelerator_FIR_FIR_HW_master_resource2_read0 => internal_accelerator_FIR_FIR_HW_master_resource2_read0,
      accelerator_FIR_FIR_HW_master_resource3_address0 => internal_accelerator_FIR_FIR_HW_master_resource3_address0,
      accelerator_FIR_FIR_HW_master_resource3_byteenable0 => internal_accelerator_FIR_FIR_HW_master_resource3_byteenable0,
      accelerator_FIR_FIR_HW_master_resource3_write0 => internal_accelerator_FIR_FIR_HW_master_resource3_write0,
      accelerator_FIR_FIR_HW_master_resource3_writedata0 => internal_accelerator_FIR_FIR_HW_master_resource3_writedata0,
      cpu_readdata0 => internal_cpu_readdata0,
      FIR_HW_begin0 => FIR_HW_begin0,
      FIR_HW_functiondata0 => FIR_HW_functiondata0,
      FIR_HW_read0 => FIR_HW_read0,
      FIR_HW_select0 => FIR_HW_select0,
      accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0 => accelerator_FIR_FIR_HW_master_resource0_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource1_readdata0 => accelerator_FIR_FIR_HW_master_resource1_readdata0,
      accelerator_FIR_FIR_HW_master_resource1_readdatavalid0 => accelerator_FIR_FIR_HW_master_resource1_readdatavalid0,
      accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0 => accelerator_FIR_FIR_HW_master_resource1_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource2_readdata0 => accelerator_FIR_FIR_HW_master_resource2_readdata0,
      accelerator_FIR_FIR_HW_master_resource2_readdatavalid0 => accelerator_FIR_FIR_HW_master_resource2_readdatavalid0,
      accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0 => accelerator_FIR_FIR_HW_master_resource2_waitrequest_n0,
      accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0 => accelerator_FIR_FIR_HW_master_resource3_waitrequest_n0,
      accelerator_FIR_FIR_HW_output_buffer_internal_memory0_base_address0 => accelerator_FIR_FIR_HW_output_buffer_internal_memory0_base_address0,
      clk => clk,
      reset_n => reset_n
    );


  --sub_FIR_HW0, which is an e_avalon_slave
  --accelerator_FIR_FIR_HW_master_resource0, which is an e_avalon_master
  --accelerator_FIR_FIR_HW_master_resource1, which is an e_avalon_master
  --accelerator_FIR_FIR_HW_master_resource3, which is an e_avalon_master
  --accelerator_FIR_FIR_HW_master_resource2, which is an e_avalon_master
  --the_cpu_registers0, which is an e_instance
  the_cpu_registers0 : accelerator_FIR_FIR_HW_cpu_registers0
    port map(
      cpu_readdata1 => internal_cpu_readdata1,
      cpu_waitrequest_n0 => internal_cpu_waitrequest_n0,
      slave_address0 => internal_slave_address0,
      slave_functiondata0 => slave_functiondata0,
      slave_read0 => internal_slave_read0,
      FIR_HW0 => FIR_HW0,
      cpu_address0 => cpu_address0,
      cpu_clk => cpu_clk,
      cpu_reset_n => cpu_reset_n,
      cpu_select0 => cpu_select0,
      cpu_write0 => cpu_write0,
      cpu_writedata0 => cpu_writedata0,
      reset_n => reset_n,
      slave_readdata0 => slave_readdata0,
      slave_waitrequest_n0 => slave_waitrequest_n0
    );


  FIR_HW_functiondata0 <= slave_functiondata0;
  --cpu_interface0, which is an e_avalon_slave
  --internal_master0, which is an e_avalon_master
  dummy_master_write <= std_logic'('0');
  dummy_master_writedata <= std_logic_vector'("00000000000000000000000000000000");
  dummy_waitrequest_sink <= dummy_master_waitrequest;
  dummy_master_address <= std_logic_vector'("00000000000000000000000000000000");
  dummy_chipselect_sink <= dummy_slave_chipselect;
  dummy_address_sink <= dummy_slave_address;
  dummy_slave_readdata <= std_logic_vector'("00000000000000000000000000000000");
  --dummy_master, which is an e_avalon_master
  --dummy_slave, which is an e_avalon_slave
  FIR_HW0 <= std_logic_vector'("00000000000000000000000000000000");
  --vhdl renameroo for output signals
  FIR_HW_waitrequest_n0 <= internal_FIR_HW_waitrequest_n0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource0_address0 <= internal_accelerator_FIR_FIR_HW_master_resource0_address0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource0_byteenable0 <= internal_accelerator_FIR_FIR_HW_master_resource0_byteenable0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource0_write0 <= internal_accelerator_FIR_FIR_HW_master_resource0_write0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource0_writedata0 <= internal_accelerator_FIR_FIR_HW_master_resource0_writedata0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource1_address0 <= internal_accelerator_FIR_FIR_HW_master_resource1_address0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource1_flush0 <= internal_accelerator_FIR_FIR_HW_master_resource1_flush0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource1_read0 <= internal_accelerator_FIR_FIR_HW_master_resource1_read0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource2_address0 <= internal_accelerator_FIR_FIR_HW_master_resource2_address0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource2_flush0 <= internal_accelerator_FIR_FIR_HW_master_resource2_flush0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource2_read0 <= internal_accelerator_FIR_FIR_HW_master_resource2_read0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource3_address0 <= internal_accelerator_FIR_FIR_HW_master_resource3_address0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource3_byteenable0 <= internal_accelerator_FIR_FIR_HW_master_resource3_byteenable0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource3_write0 <= internal_accelerator_FIR_FIR_HW_master_resource3_write0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_master_resource3_writedata0 <= internal_accelerator_FIR_FIR_HW_master_resource3_writedata0;
  --vhdl renameroo for output signals
  accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0 <= internal_accelerator_FIR_FIR_HW_output_buffer_internal_memory0_q0;
  --vhdl renameroo for output signals
  cpu_readdata0 <= internal_cpu_readdata0;
  --vhdl renameroo for output signals
  cpu_readdata1 <= internal_cpu_readdata1;
  --vhdl renameroo for output signals
  cpu_waitrequest_n0 <= internal_cpu_waitrequest_n0;
  --vhdl renameroo for output signals
  slave_address0 <= internal_slave_address0;
  --vhdl renameroo for output signals
  slave_read0 <= internal_slave_read0;

end europa;



